/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>



#include <library.h>

#include <process.h>

#include <nwenvrn.h>

#include <advanced.h>

#include <nwqueue.h>

#include <nwmsg.h>

#include <niterror.h>

#include <io.h>



#define MYNAME "ATPSENH "

#define MYLEN strlen(MYNAME)



LONG libHandle=0;

int  debugOpt=0,run=0,theConsole=0,patchCall=0,callCount=0,filterPS=1;

WORD theWord=0x8000;



LONG myCommand(LONG screenID,BYTE *cmdline);



/* return true if job file contains postscript */



int isPSjob(int f)

{

char tmp[256],*p;

int isPS=1;



*tmp=0;

if (read(f,tmp,256)!=-1)

  {

  lseek(f,0l,SEEK_SET);

  isPS=0;

  if (p=strtok(tmp,"\004\n\r"))

    if (!strncmp(p,"%!",2))

      isPS=1;

  }

return isPS;

}



struct commandParserStructure

  myParserStruct={

    0,

    myCommand,

    0 };





int clientCleanupFunction(void *p)

{

return 0;

}



/* cleanup function:

   deregisters library */



void cleanup(void)

{

if (libHandle)

   DeregisterLibrary(libHandle);

}



/* remove CC Handler */



void removeCCHandler(void)

{

UnRegisterConsoleCommand(&myParserStruct);

}



void dispstat(void)

{

      ConsolePrintf("%s%s, %ld calls, theWord: %04X, %s, debug:%d\n\r",

      MYNAME,patchCall ? "ON" : "OFF",callCount,theWord,filterPS ? "PS only":"any job",

      debugOpt);

}



/* my console command routine */



LONG myCommand(LONG screenID,BYTE *cmdline)

{

char *cmd;

if (screenID==theConsole)

  {

  if (!strnicmp(cmdline,MYNAME,MYLEN))

    {

    cmd=strtok(cmdline+MYLEN," ");

    if (!strcmp(cmd,"exit"))

      {

      run=0;

      return 0;

      }

    if (!stricmp(cmd,"off"))

      {

      patchCall=0;

      dispstat();

      return 0;

      }

    if (!stricmp(cmd,"on"))

      {

      patchCall=1;

      dispstat();

      return 0;

      }

    if (!stricmp(cmd,"psonly"))

      {

      filterPS=1;

      dispstat();

      return 0;

      }

    if (!stricmp(cmd,"any"))

      {

      filterPS=0;

      dispstat();

      return 0;

      }

    if (!stricmp(cmd,"help"))

      {

      ConsolePrintf("%scommands: debug, exit, on, off, psonly, any, stat, help, 0..ffff\n",

      MYNAME);

      return 0;

      }

    if (!stricmp(cmd,"debug"))

      {

      debugOpt=!debugOpt;

      dispstat();

      return 0;

      }

    if (!stricmp(cmd,"stat"))

      {

      dispstat();

      return 0;

      }

    if (strchr("0123456789abcdef",tolower(*cmd))!=NULL)

      {

      theWord=(WORD)strtoul(cmd,NULL,16);

      dispstat();

      return 0;

      }

    return 1;

    }

  return 1;

  }

else

  return 1;

}



/* hook for NWQBeginJobService:

   - force banner page

   - if filterPS==1, remove non PS jobs

*/



int NWQbeginJobService (LONG queueID, LONG jobType, NWQJobRec_t *jobInfo, int *handle)

{

int cC;

WORD station[1];

BYTE result[1];

static char tmp[128];

cC=NWQBeginJobService (queueID, jobType, jobInfo, handle);

if (debugOpt)

  ConsolePrintf("ATPSENH: printControlFlags:%04X\n",

  ((NWQPrintServerRec_t*)jobInfo->jobServerRecord)->printControlFlags);

if (!patchCall)

  return cC;

if (cC)

  return cC;

((NWQPrintServerRec_t*)jobInfo->jobServerRecord)->printControlFlags|=theWord;

callCount++;

if (filterPS)

  if (!isPSjob(*handle))

    {

    if (!NWQEndJobService(queueID,jobInfo->job.num,0l,*handle))

      {

      station[0]=jobInfo->client.clientConnNum;

      sprintf(tmp,"Non PS job (%s) removed",jobInfo->textJobDescription);

      SendBroadcastMessage(tmp,station,result,1);

      return NO_Q_JOB;

      }

    }

return cC;

}



void main(int argc,char *argv[])

{

int myID;

LONG consoleCommandTag;

unsigned myNLMHandle;

myID=GetNLMID();

myNLMHandle=GetNLMHandle();



theConsole=__GetScreenID(CreateScreen("System Console",0));



if ((libHandle=RegisterLibrary(clientCleanupFunction))!=-1)

  {

  ConsolePrintf("Library registered\n");

  if (consoleCommandTag=AllocateResourceTag(myNLMHandle,

    "ATPSENH console command",ConsoleCommandSignature))

    {

    myParserStruct.RTag=(struct ResourceTagStructure *)consoleCommandTag;

    RegisterConsoleCommand(&myParserStruct);

    atexit(removeCCHandler);

    run=1;

    patchCall=1;

    }

  AtUnload(cleanup);

  dispstat();

  do {

     delay(2000);

     } while(run);

  cleanup();

  }

}



