#include <ctype.h>

#include <errno.h>

#include <conio.h>

#include <io.h>

#include <niterror.h>

#include <nwenvrn.h>

#include <nwmisc.h>

#include <nwtypes.h>

#include <process.h>

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <sys\types.h>

#include <time.h>

#include <nwbindry.h>

#include <nwconn.h>

#include <nwcntask.h>

#include <sys\socket.h>

#include <netinet\in.h>

#include <arpa\inet.h>



#define DELAY_TIME   200            /* delay time for clock update */

#define ONE_MINUTE   60000

#define DEFAULT      30



struct tm *Localtime(time_t *t);

time_t isMEST(time_t *t);



/* Differenz RFC Standardzeit in Sekunden set 1900 bzgl. Berkely Zeitzone

   zur Unixzeit, die ab 1970 geht. Wenn man von der RFC Zeit diesen Wert

   abzieht, gelangt man zur Unix-Standardzeit. */



#define STD_TIME  (LONG) 86400l*(365l*70l + 17l)

#define CLOCK_POS    7,5

#define DATE_POS     5,15

#define STATUS_POS   20,15

#define NCHARS       13

#define MINZEIT      10

#define DEFAULT_DELTA_TIME 5

#define MAXDELTATIME (LONG) 86400l



struct

{

   BYTE Sec100;

   BYTE Second;

   BYTE Minute;

   BYTE Hour;

   BYTE DayOfMonth;

   BYTE DayOfWeek;

   BYTE Month;

   BYTE Year;

   BYTE Status;

} clockdata;





/* 8x8 bitmap of chars '.'..':' */



char char8x8 [ 104 ] = {

0x00,0x00,0x00,0x00,0x00,0x38,0x38,0x00,0x06,0x0c,0x18,0x30,0x60,0xc0,0x80,0x00,

0x7c,0xc6,0xce,0xde,0xf6,0xe6,0x7c,0x00,0x18,0x78,0x18,0x18,0x18,0x18,0x7e,0x00,

0x7c,0xc6,0x0c,0x18,0x30,0x66,0xfe,0x00,0x7c,0xc6,0x06,0x3c,0x06,0xc6,0x7c,0x00,

0x0c,0x1c,0x3c,0x6c,0xfe,0x0c,0x0c,0x00,0xfe,0xc0,0xfc,0x06,0x06,0xc6,0x7c,0x00,

0x7c,0xc6,0xc0,0xfc,0xc6,0xc6,0x7c,0x00,0xfe,0xc6,0x06,0x0c,0x18,0x18,0x18,0x00,

0x7c,0xc6,0xc6,0x7c,0xc6,0xc6,0x7c,0x00,0x7c,0xc6,0xc6,0x7e,0x06,0xc6,0x7c,0x00,

0x00,0x1c,0x1c,0x00,0x00,0x1c,0x1c,0x00

};



char boxdata [ NCHARS * 128 ];  /* NCHARS * 16 bytes/row * 8 rows */

char *myname;

int  updateInterval = DEFAULT;   /* default 30 minutes */

int  loginStatus = -1;

int  ErrStatus = -1;

int  TCP_Socket;

int  run = 1;

int  nver; // contains Netware major version

int  Zeitdifferenz = -1,enableBell=0;

clock_t deltaTime=DEFAULT_DELTA_TIME,currentDeltaTime=0,maxdeltaTime=MAXDELTATIME;

long nrOfSyncs=0;

clock_t dst=0;  // set to 3600 by Localtime if daylight saving is active



/* Initialize boxdata */



void fillboxdata ( void )

{

   int i;

   int j;

   int k;



   for ( i = 0; i < NCHARS * 8; i++ )

   {

      for ( j = 0, k = 0x80; j < 16; j += 2, k >>= 1 )

      {

         /* Set Character & Attribute */

         boxdata [ ( i << 4 ) + j ] = ( ( char8x8 [ i ] & k ) ? '' : ' ' );

         boxdata [ ( i << 4 ) + j + 1 ] = 0x0e;

      }

   }

}





/* Display string s in 8x8 big letters */



void bigprint ( int x, int y, char *s )

{

   int j;

   char b;



   for ( j = 0; ( j < 8 ) && s [ j ]; j++ )

   {

      b = s [ j ];

      if ( b < '.' || b > ':' ) break;

      CopyToScreenMemory ( 8, 8, &boxdata [ ( b - '.' ) * 128 ], x + 8 * j, y );

   }

}



/* Read data packet from internal clock. */



int readClock ( void )

{

   time_t     t;

   struct tm *tlocal;



   {

      t=time (NULL);               /* get seconds since 1970 */

      tlocal = localtime ( &t );  // L

      clockdata.Second     = tlocal -> tm_sec;

      clockdata.Minute     = tlocal -> tm_min;

      clockdata.Hour       = tlocal -> tm_hour;

      clockdata.DayOfMonth = tlocal -> tm_mday;

      clockdata.Month      = tlocal -> tm_mon + 1;

      clockdata.Year       = tlocal -> tm_year;

      clockdata.Status     = 'I';

      return ( 0 );

   }

}



/* localtime for MET with daylight saving support */



struct tm *Localtime(time_t *t)

{

struct tm *tnow;

time_t dst;



tnow=localtime(t);

if (nver>=4)

// if (CheckNetWareVersion(4,0,0,1,1)!= VERSION_NUMBER_TOO_LOW)

  return tnow;

dst=isMEST(t);

*t+=dst;

return localtime(t);

}



/* return 3600 if daylight saving is active in MET */



time_t isMEST(time_t *t)

{

int days[12]={0,31,59,90,120,151,181,212,243,273,304,334};

struct tm *tnow;

time_t T;

int add1=0,d0,d1,d2,h0,h1,h2;

if (t)

  tnow=localtime(t);

else

  {

  time(&T);

  tnow=localtime(&T);

  }



add1=((tnow->tm_year) % 4)==0;

d0=(((tnow->tm_year)*5)/4)%7;



d1=days[3]+add1-((days[3]+d0)%7)-1;

d2=days[9]+add1-((days[9]+d0)%7)-1;



h1=d1*24+2; h2=d2*24+2;

h0=tnow->tm_yday*24+tnow->tm_hour;

if (h0>=h1 && h0<h2)

  return 3600;

else

  return 0;

}



void tcp_sync ( char *timeserver )

{

   LONG                hostTime;

   struct tm          *hts;

   struct sockaddr_in  server_sockaddr;

   int                 rc;

   time_t              Time_t_Start;

   time_t              Time_t_Stopp,tnow,dst;

   int                 AnzWied;



   server_sockaddr.sin_addr.s_addr = inet_addr ( timeserver );



   if ( server_sockaddr.sin_addr.s_addr == -1 )

   {

      run = 0;

      printf ( "%s is a malformed address\r\n", timeserver );

      delay(3000);

      ExitThread ( TSR_THREAD, 42 );

   }



   server_sockaddr.sin_family = AF_INET;

   server_sockaddr.sin_port   = htons ( 37 );



   AnzWied = 0;



   do

   {

      loginStatus = -1;



      TCP_Socket = socket ( PF_INET, SOCK_STREAM, 0 );

      if ( TCP_Socket == -1 )

      {

         loginStatus = 1;

         ErrStatus = errno;

      }

      else

      {

         rc = connect ( TCP_Socket, ( struct sockaddr * ) & server_sockaddr,

                        sizeof ( server_sockaddr )                           );

         if ( rc == -1 )

         {

            loginStatus = 2;

            ErrStatus = errno;

            rc = close ( TCP_Socket );

         }

         else

         {

            rc = write ( TCP_Socket, &hostTime, sizeof ( hostTime ) );

            if ( rc == -1 )

            {

                loginStatus = 3;

                ErrStatus = errno;

                rc = close ( TCP_Socket );

            }

            else

            {

                Time_t_Start = time ( & Time_t_Start );

                rc = read ( TCP_Socket, &hostTime, sizeof ( hostTime ) );

                Time_t_Stopp = time ( & Time_t_Stopp );



                if ( rc == -1 )

                {

                   loginStatus = 4;

                   ErrStatus = errno;

                   rc = close ( TCP_Socket );

                }

                else

                {

                   if ( rc == sizeof ( hostTime ) )

                   {

                      dst=(nver<4) ? isMEST(NULL) : 0;

                      hostTime = LongSwap ( hostTime ) - STD_TIME; //timezone;

                      Zeitdifferenz = difftime ( Time_t_Stopp, Time_t_Start ) / 2;

                      if ( Zeitdifferenz > 0)

                        hostTime+=Zeitdifferenz;

                      hostTime+=dst;

                      hts = localtime ( &hostTime );

                      tnow=time(&tnow);

                      tnow+=dst;

                      currentDeltaTime=abs(tnow-hostTime-dst);

                      if ((currentDeltaTime>=deltaTime)&&

                          (currentDeltaTime<maxdeltaTime))

                      {

                      if (enableBell)

                        RingTheBell();

                      SetFileServerDateAndTime ( hts -> tm_year, hts -> tm_mon + 1,

                                                 hts -> tm_mday, hts -> tm_hour,

                                                 hts -> tm_min, hts -> tm_sec       );

                      nrOfSyncs++;

                      currentDeltaTime=0;

                      }

                      loginStatus = 0;

                   }

                   else

                   {

                      loginStatus = 42;

                      ErrStatus = errno;

                   }

                }

            }

         }

      }



      rc = close ( TCP_Socket );



      if ( loginStatus == 0 || AnzWied >= 10 )

      {

         delay ( updateInterval * ONE_MINUTE );

         if ( loginStatus == 0 )

         {

            ErrStatus = 0;

         }

         AnzWied = 0;

      }

      else

      {

         AnzWied = AnzWied + 1;

      }

   }

   while ( TRUE );

}







void cleanup()

{

   close ( TCP_Socket );

}



void usage()

   {

      printf ( "Usage %s ip# [-d delta time] [-u update interval] [-TZ] [-md max delta] [-B]\n", myname );

      printf ( "  ip#             : decimal IP-Address of Timeserver to synchronize with\n" );

      printf ( "  delta time      : minimum time difference in sec before \n");

      printf ( "                    synchronization occurs, default is 5 s\n");

      printf ( "  update interval : interval in minutes, default are 30 minutes\n" );

      printf ( "  -TZ:              interactively enter difference GMT - localtime  in\n");

      printf ( "                    sec, for Germany enter -3600\n");

      printf ( "  -md:              maximum delta time, defaults to %ld\n",MAXDELTATIME);

      printf ( "  -B:               ring the bell at any sync\n");

      printf ( " Example : LOAD %s 132.199.3.32 -u 30 -d 10\n",myname);

      printf ( " Time will be updated every 30 minutes if it is out of sync by more than 10 s.\n");

      exit ( 0 );

   }



main ( int argc, char *argv [] )

{

   int   i;

   char *timeServer = NULL;

   char  timeString [ 16 ];

   int   myScreen;



   fillboxdata ();

   myname=argv[0];

   if (CheckNetWareVersion(4,0,0,1,1)!= VERSION_NUMBER_TOO_LOW)

     nver=4;

   else

     nver=3;

   if ( argc==1 || argv[1][0]=='?' )

     usage();

   timeServer=argv[1];  /* string containing IP number of time server */



   for (i=2;i<argc;i++)

     {

     if (!strcmp(argv[i],"-d"))

       if (argc>i)

         deltaTime=atoi(argv[++i]);

     if (!strcmp(argv[i],"-md"))

       if (argc>i)

         maxdeltaTime=atol(argv[++i]);

     if (!strcmp(argv[i],"-u"))

       if (argc>i)

         updateInterval=atoi(argv[++i]);

     if (!strcmp(argv[i],"-TZ"))

       {

       printf("Enter time zone : ");

       scanf("%d",&timezone);

       }

     if (!strcmp(argv[i],"-B"))

       enableBell=1;

     }



/* daylight saving time auf 0 setzen, weil es mit SET TIMEZONE nicht geht */



   if (nver<4)

     daylight=0;



   myScreen = GetCurrentScreen(); /* screen handle besorgen */

   SetAutoScreenDestructionMode( TRUE );

   clrscr();

   printf ( "BIGCLOCK V 1.23 (c) 1992- 1995 Peter Heitzer, Edmund Weber\n");

   printf ( "Timeserver %s, update every %d min for delta time > %d seconds\n",

             timeServer,updateInterval,deltaTime);

   printf (  "Max delta time %8ld s\n",maxdeltaTime);

   printf (  "Running on NetWare %d.x\n",nver);

   HideInputCursor();



   loginStatus = BeginThread ( tcp_sync, NULL, 1024, timeServer );



#ifdef DEBUG

   gotoxy ( 0, 17 );

   printf ( "tcp_sync gestartet\n" );

#endif



   AtUnload ( cleanup );



   if ( loginStatus != EFAILURE )

   {

      loginStatus = 0;

   }



   /* Read clock every 1/4 sec and set server time every minute. Also the current

      time is displayed as */



   do

   {

         CheckIfScreenDisplayed(myScreen,TRUE);

         readClock();

         sprintf ( timeString, "%02d:%02d:%02d",

                               clockdata.Hour,

                               clockdata.Minute,

                               clockdata.Second );

         bigprint ( CLOCK_POS, timeString );



         gotoxy ( DATE_POS );

         printf ( "%02d.%02d.%02d %s", clockdata.DayOfMonth,

                                       clockdata.Month,

                                       clockdata.Year,

                                       isMEST(NULL) ? "MEST" : "MET " );



         if ( timeServer != NULL )

         {

            gotoxy ( STATUS_POS );

            printf ( "Nr of syncs: %-8ld, current delta time %-8ld s",

                      nrOfSyncs,currentDeltaTime);

            gotoxy ( STATUS_POS+1 );

            printf ( "TCP status: ");

            if (loginStatus)

              printf("%2d",loginStatus);

            else

              printf("OK");

         }



      delay(DELAY_TIME);

   }

   while ( run );

}

