/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <nwtypes.h>

#include <nwbindry.h>

#include <nwenvrn.h>

#include <time.h>

#include <advanced.h>

#include <process.h>

#include <nwmisc.h>



#define MAXENTRIES 32000



typedef struct {

               char mailname[60];

               char username[48];   // can be replaced by user ID

               char server[52];     // redundant always the same

               } ENTRY;



typedef struct {

               char mailname[60];

               long userID;

               } PACKED_ENTRY;



// saves a lot of memory 8000 entries occupy only about 512k not 1.3 MB



static ENTRY *entries[MAXENTRIES],*entry;

char *progName="CH_SYN";

LONG update=0,hCreate=0;



int pstricmp(const char *P1,const char *P2)

{

ENTRY **p1,**p2;

p1=(ENTRY **)P1;p2=(ENTRY **)P2;

ThreadSwitch();

return stricmp((*p1)->mailname,(*p2)->mailname);

}



void objCreate(LONG objID)

{

update=objID;

}



void objDelete(LONG objID)

{

update=objID;

}



void cleanup(void)

{

if (hCreate)

  UnregisterForEvent(hCreate);

}



void usage(char *msg)

{

printf("%sUsage: %s file\n",msg,progName);

exit(0);

}



char *mailname(BYTE *opt)

{

int i=0;

while (i<126) {

  switch (opt[i]) {

    case 4 : return &opt[i+2];

    case 0 : i=128; break;

    default : i+=opt[i+1];

    }

  }

return NULL;

}



int updateDatabase(char *filename)

{

FILE *f;

char oName[48],*mn,server[48];

long oID;

int m,i;

BYTE mailopt[128],buf[128];

int num=0,n;

time_t t;

WORD oType;



f=fopen(filename,"wb");

if (f==NULL)

  return 1;

GetFileServerName(0,server);

if (GetBinderyObjectName(LongSwap(update),oName,&oType))

  return 1;

printf("New object %s, type %x\n",oName,oType);

if (oType!=OT_USER)

  return 0;

t=time(NULL);

printf("Update started at %s",ctime(&t));

for (oID=-1;!ScanBinderyObject("*",OT_USER,&oID,oName,0,0,0,0);)

  if (!ReadPropertyValue(oName,OT_USER,"MAIL_OPTIONS",1,&mailopt,&m,0))

    if (mn=mailname(mailopt))

      for (i=0;i<10;i++)

      {

      if ((entry=entries[num]=calloc(1,sizeof(ENTRY)))==NULL)

        {

        fprintf(stderr,"Alloc error\n");

        return 42;

        }

      strcpy(entry->username,oName);

      strcpy(entry->mailname,mn);

      strcpy(entry->server,server);

      num++;

//      printf("%-10s : '%s'\n",oName,mn);

      }

if (num)

   {

   fprintf(stderr,"Sorting %d usernames ... ",num);

   qsort(entries,num,sizeof(ENTRY *),pstricmp);

   fprintf(stderr,"done\n");

   memset(buf,0,128);

   strcpy(buf,"Charon Alias Database\012\032");

   fwrite(buf,1,128,f);

   for (n=0;n<num;n++)

     {

     entry=entries[n];

     fwrite(entry,sizeof(ENTRY),1,f);

     }

   for (n=0;n<num;n++)

     free(entries[n]);

  fclose(f);

  }

t=time(NULL);

printf("Update ended at %s",ctime(&t));

return 0;

}





int main(int argc, char *argv[])

{

if (argc==1)

  usage("");

AtUnload(cleanup);

hCreate=RegisterForEvent(EVENT_CREATE_BINDERY_OBJ,objCreate,NULL);

for (;;)

  if (update)

    {

    updateDatabase(argv[1]);

    update=0;

    }

  else

    ThreadSwitch();

}



