#include <conio.h>

#include <stdio.h>

#include <stddef.h>

#include <io.h>

#include <fcntl.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <dos.h>



#define BUFS 8192



char buffer[BUFS];



/* copy file */



int copyfile(int srcHandle, int destHandle, int copyMask)

{

int cC;

LONG srcOffset=0,destOffset=0,bytes;

do {

   cC=0;

   (copyMask & 0xf0) ? cC=DOSRead(srcHandle,srcOffset,buffer,BUFS,&bytes) :

   bytes = read(srcHandle,buffer,BUFS);

   if (cC || bytes==-1l)

     return(-1);

   if (bytes==0)

     break;

   srcOffset+=bytes;

   (copyMask & 0x0f) ? cC=DOSWrite(destHandle,destOffset,buffer,bytes,&bytes) :

   bytes = write(destHandle,buffer,bytes);

   if (cC || bytes==-1l)

     return(-1);

   destOffset+=bytes;

   } while (1);

return(0);

}



/* copy DOS file to Netware file */



int copyDOS2NW(char *dosfile, char *nwfile)

{

int cC;

if (cC=DOSCopy(nwfile,dosfile))

  {

  printf("DOSCopy returned error %04X\n",cC);

  return(cC);

  }

return 0;

}



/* copy DOS file to DOS file */



int copyDOS2DOS(char *srcfile, char *destfile)

{

int cC,src,dest;



if ((src=DOSsopen(srcfile,O_RDONLY,0,0))==-1)

  return(-1);

if ((dest=DOSsopen(destfile,O_RDWR | O_CREAT,0,0))==-1)

  {

  DOSClose(src);

  return -1;

  }

cC=copyfile(src,dest,0xdd);

DOSClose(src);

DOSClose(dest);

return cC;

}



/* copy Netware file to DOS file */



int copyNW2DOS(char *srcfile, char *destfile)

{

int cC,src,dest;



if ((src=open(srcfile,O_RDONLY))==-1)

  return(-1);

if ((dest=DOSsopen(destfile,O_RDWR | O_CREAT,0,0))==-1)

  {

  close(src);

  return -1;

  }

cC=copyfile(src,dest,0x0d);

close(src);

DOSClose(dest);

return cC;

}



/* copy Netware file to Netware file */



int copyNW2NW(char *srcfile, char *destfile)

{

int cC,src,dest;



if ((src=open(srcfile,O_RDONLY))==-1)

  return(-1);

if ((dest=open(destfile,O_RDWR | O_CREAT,0))==-1)

  {

  close(src);

  return -1;

  }

cC=copyfile(src,dest,0x00);

close(src);

close(dest);

return cC;

}



void main(int argc, char *argv[])

{

int cC,copyMask=0;

char src[256],dest[256];



if (argc<3)

  {

  printf("Usage load %s sourcefile destination\n",argv[0]);

  printf("  sourcefile:  file to copy, no wildcards allowed\n");

  printf("  destination: destination file, no wildcards allowed\n");

  printf("If sourcefile or destination contains drive letter, e.g. A:test.dat then \n");

  printf("it is assumed to be a DOS name else it is assumed to be a Netware name\n");

  return;

  }



chdir("SYS:SYSTEM");



strupr(argv[1]);

strupr(argv[2]);

if (argv[1][1]==':')

  copyMask |= 0xd0;

if (argv[2][1]==':')

  copyMask |= 0x0d;



strcpy(src,argv[1]);

strcpy(dest,argv[2]);



if (copyMask)

  if (!DOSPresent())

    {

    printf("DOS not present in memory\n");

    return;

    }



switch (copyMask) {

  case 0x00 : cC=copyNW2NW(src,dest); break;

  case 0x0d : cC=copyNW2DOS(src,dest); break;

  case 0xd0 : cC=copyDOS2NW(src,dest); break;

  case 0xdd : cC=copyDOS2DOS(src,dest); break;

  }

if (cC==0)

  printf("%s copied to %s\n",src,dest);

else

  printf("Error %x occured\n",cC);

}

