/*

Universal Hook SDK

*/



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <io.h>



#include <library.h>

#include <process.h>

#include <nwenvrn.h>

#include <advanced.h>

#include <nwqueue.h>

#include <nwmsg.h>

#include <niterror.h>

#include <nwdsapi.h>

#include <nwcntask.h>

#include <nwsnut.h>

#include <nwmisc.h>

#include <time.h>



#define MYINI "SYS:SYSTEM\\HOOKSDK.INI"



NUTInfo *handle;

LONG    NLMHandle;

LONG    allocTag;

int     CLIBScreenID,escapeMode,inForm=0;

PCB     *myPortal;



enum { MSG_NAME, MSG_VER, MSG_LIST, MSG_FORM };

char    *messages[16]={ "HOOKSDK",

                        "1.00 (c) 1997 Peter Heitzer",

                        "HOOKSDK options",

                        "HOOKSDK options"

                        };

char gtmp[256];  // global temp buffer

NWDSContextHandle   dContext;



LONG libHandle=0;

int  maxLen=0,queueCnt=0,run=0;



/* patch options */



int patchActive=1, excludeOption=0;

char excludeList[256];



int clientCleanupFunction(void *p)

{

return 0;

}



/* cleanup function:

   deregisters library and restores nut */



void cleanup(void)

{

if (libHandle)

  DeregisterLibrary(libHandle);

if (handle)

  NWSRestoreNut(handle);

if (CLIBScreenID)

  DestroyScreen(CLIBScreenID);

NWDSFreeContext(dContext);

}



int readParams(void)

{

FILE *f;

char line[256],*q,*p1;



if ((f=fopen(MYINI,"r"))==NULL)

  return 1;



do {

   if (fgets(line,256,f)==NULL)

     break;

   if (*line==';')

     continue;

   if (q=strtok(line,","))

     if (p1=strtok(NULL,",\n\r"))

       {

       if (!stricmp(q,"Exclude"))

         strcpy(excludeList,p1);

       }

   } while (1);

fclose(f);

return 0;

}



/* check if good username, i.e. 3 characters and 5 digits as in abc12345

   returns 0 if ok 1 else

*/



int verifyName(char *uname)

{

int i;

for (i=0;i<3;i++)

  if (!isalpha(uname[i]))

    return 1;

for (i=3;i<8;i++)

  if (!isdigit(uname[i]))

    return 1;

return 0;

}



/* convert name to RFC syntax, i.e. cn=xx.ou=yy -> xx.yy */



char *toRFC(char *s)

{

static char rfc[256];

       char tmp[256],*p,*peq;

int    first;



*rfc=0;



if (*s=='.') // absolute name, keep dot

  {

  strcpy(rfc,".");

  strcpy(tmp,s+1);

  }

else

  strcpy(tmp,s);



for (first=1,p=strtok(tmp,".");p;p=strtok(NULL,"."))

  {

  if (!first)

    strcat(rfc,".");

  else

    first=0;

  if (peq=strchr(p,'='))

    strcat(rfc,peq+1);

  else

    strcat(rfc,p);

  }

return strlwr(rfc);

}



/* hook comes here! */



/*

hook for NWDSCanonicalizeName

*/



NWDSCCODE nWDSGetEffectiveRights(

        NWDSContextHandle context,

        char    NWFAR *subjectName,

        char    NWFAR *objectName,

        char    NWFAR *attrName,

        uint32  NWFAR *privileges)

{

NWDSCCODE cC;



cC=NWDSGetEffectiveRights(context,

                          subjectName,

                          objectName,

                          attrName,

                          privileges);

if (!patchActive)

  return cC;

ConsolePrintf("NWDSGetEffectiveRights: h: %lx, s: %s, o: %s, a: %s, p:%lx -> %x\n",

context,subjectName,objectName,attrName,*privileges,cC);

return cC;

}



int nWDSCanonicalizeName(

    NWDSContextHandle   contextHandle,

    char *              shortName,

    char *              longName)



{

char tmp[256];

int cC;



if (!patchActive)

  return NWDSCanonicalizeName (contextHandle,shortName,longName);



cC=NWDSCanonicalizeName (contextHandle,shortName,longName);

ConsolePrintf("NWDSCanonicalizeName: %s -> %s : %x\n",shortName,longName,cC);

/* NWSDisplayTextInPortal(0,0,tmp,VNORMAL,myPortal);

  if (!inForm)

    NWSUpdatePortal(myPortal); */

return cC;

}



int nWDSMapIDToName(

    NWDSContextHandle   contextHandle,

    int                 connID,

    long                localID,

    char *              longName)



{

char tmp[256];

int cC;



if (!patchActive)

  return NWDSMapIDToName (contextHandle,connID,localID,longName);



cC=NWDSMapIDToName (contextHandle,connID,localID,longName);

ConsolePrintf("NWDSMapIDToName: %lx -> %s : %x\n",localID,longName,cC);

/* NWSDisplayTextInPortal(0,0,tmp,VNORMAL,myPortal);

  if (!inForm)

    NWSUpdatePortal(myPortal); */

return cC;

}



int nWDSMapNameToID(

    NWDSContextHandle   contextHandle,

    int                 connID,

    char *              longName,

    long *              localID)



{

char tmp[256];

int cC;



if (!patchActive)

  return NWDSMapNameToID (contextHandle,connID,longName,localID);



cC=NWDSMapNameToID (contextHandle,connID,longName,localID);



ConsolePrintf("NWDSMapNameToID: %s -> %x : %x\n",longName,*localID,cC);

/* NWSDisplayTextInPortal(0,0,tmp,VNORMAL,myPortal);

  if (!inForm)

    NWSUpdatePortal(myPortal); */

return cC;

}



int ListAction (LONG keyPressed, LIST **elementSelected, LONG *itemNumber, void *listParameter)

{

char tmp[16];



elementSelected = elementSelected;

listParameter = listParameter;



if (keyPressed == M_ESCAPE)

  return 1;



NWSPushList(handle);

NWSInitForm(handle);



NWSAppendCommentField (1, 1, "Patch active: ", handle);

NWSAppendBoolField (1, 20, NORMAL_FIELD, &patchActive, NULL, handle);

NWSAppendCommentField (2, 1, "Exclude option: ", handle);

NWSAppendBoolField (2, 20, NORMAL_FIELD, &excludeOption, NULL, handle);

NWSAppendCommentField (3, 1, "Exclude list: ", handle);

NWSAppendCommentField (3, 20, excludeList, handle);



inForm=1;

NWSEditPortalForm (MSG_FORM, 5, 40, 5, 70, F_NOVERIFY, F_NO_HELP, 3, handle);

NWSDestroyForm (handle);

NWSPopList(handle);

inForm=0; NWSUpdatePortal(myPortal);

return -1;

}



void main(int argc,char *argv[])

{

int     i;

LONG    ccode, infoPortalNumber;

PCB     *ipPtr;

WORD    screenHeight, screenWidth;



/*

if (readParams())

  {

  ConsolePrintf("Error reading %s\n",MYINI);

  return;

  }

*/

dContext = NWDSCreateContext( );



if (dContext==ERR_CONTEXT_CREATION)

  {

  ConsolePrintf("Error creating context\n");

  return;

  }





NLMHandle=GetNLMHandle();



CLIBScreenID = CreateScreen("HOOKSDK Screen", AUTO_DESTROY_SCREEN);

if (!CLIBScreenID)

  return;

allocTag = AllocateResourceTag(NLMHandle, "HOOKSDK Alloc Tag",AllocSignature);



if (!allocTag)

  {

  DestroyScreen(CLIBScreenID);

  return;

  }



if (NWSInitializeNut(MSG_NAME,MSG_VER,NORMAL_HEADER,NUT_REVISION_LEVEL,

    messages, 0, CLIBScreenID, allocTag, &handle))

        {

        DestroyScreen(CLIBScreenID);

        return;

        }



AtUnload(cleanup);



DisplayScreen(CLIBScreenID);

GetSizeOfScreen (&screenHeight, &screenWidth);



infoPortalNumber = NWSCreatePortal(14l,0l,5l,(LONG)screenWidth,

                        9l,(LONG)screenWidth-2, SAVE,

                        NULL,/* "HOOKSDK Status",*/

                        VNORMAL, SINGLE, VNORMAL, CURSOR_OFF, VIRTUAL, handle);



if (infoPortalNumber > MAXPORTALS)

  {

  printf ("Unable to create information portal\n");

  DestroyScreen(CLIBScreenID);

  return;

  }



NWSGetPCB (&ipPtr, infoPortalNumber, handle);

myPortal=ipPtr;

NWSClearPortal(myPortal);

NWSUpdatePortal(myPortal);



if ((libHandle=RegisterLibrary(clientCleanupFunction))!=-1)

  {

  ConsolePrintf("Library registered NLMID: %x\n",GetNLMID());

  run=1;

  AtUnload(cleanup);

  }



NWSInitList (handle, free);



NWSAppendToList ("Press enter to modify options",(void *) 0, handle);



NWSList (MSG_LIST, 5, 40, 1, 40,

                M_NO_SORT | M_SELECT , NULL, handle, NULL, ListAction, 0);



NWSDestroyList (handle);



while (run) delay(1000);



NWSDestroyPortal (infoPortalNumber, handle);

cleanup();

}



