/* This NLM waits for an IPX packet to be received on a special socket and

   displays its data contents */



#include <stdio.h>

#include <stdlib.h>

#include <errno.h>

#include <nwtypes.h>

#include <nwsemaph.h>

#include <nwipxspx.h>

#include <process.h>

#include <nwmisc.h>



#define LISTEN_SOCKET 0x8888 /* the socket to listen on */



/* global data */



IPX_ECB     listenECB;

IPX_HEADER  receiveHeader;

WORD        listenSocket=LISTEN_SOCKET;

LONG        listenSemaphore=NULL;

char        data[100];



/* close socket and cancel event if NLM is unloaded */



void cleanup(void)

{

IpxCancelEvent(&listenECB);

if (!IpxCheckSocket(listenSocket))

  IpxCloseSocket(listenSocket);

if (listenSemaphore!=NULL)

  CloseLocalSemaphore(listenSemaphore);

}



/* listen to packet arriving on listenSocket */



void listener(void *voidp)

{

char *p;

int i,n;



/* prepare listen ECB and listen for packet */



listenECB.queueHead=NULL;

listenECB.next=listenECB.prev=0;

listenECB.socket=listenSocket;

listenECB.fragCount=2; /* fragments for header and data */

listenECB.fragList[0].fragAddress=&receiveHeader;

listenECB.fragList[0].fragSize=sizeof(receiveHeader);

listenECB.fragList[1].fragAddress=data;

listenECB.fragList[1].fragSize=sizeof(data);

listenECB.semHandle=listenSemaphore;

while (1)

  {

  if (i=IpxReceive(listenSocket,&listenECB))

    printf("IpxReceive returned error %x\n",i);

  WaitOnLocalSemaphore(listenSemaphore);

  p=data; n=listenECB.dataLen-sizeof(receiveHeader);

  printf("\n%d bytes from %08lX:%08lX%04X%.*s",n,

  LongSwap(receiveHeader.sourceNet),LongSwap(*(LONG *)receiveHeader.sourceNode),

  IntSwap(*(WORD *)&receiveHeader.sourceNode[4]),n,data);

  }

}



void main(int argc, char *argv[])

{

int cC,i;



/* first open socket */



if (cC=IpxOpenSocket(&listenSocket))

  {

  printf("IpxOpenSocket returned error %x\n",cC);

  return;

  }

else

  {

  printf("Listening on socket %04X\n",listenSocket);

  }

listenSemaphore=OpenLocalSemaphore(0);



/* now that socket is open register cleanup function */



AtUnload(cleanup);



if ((cC=BeginThread(listener,NULL,4096,NULL))==EFAILURE)

  {

  printf("Error %x (%s) with BeginThread\n",errno,strerror(errno));

  IpxCloseSocket(listenSocket);

  return;

  }

}

