#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <conio.h>

#include <errno.h>

#include <ctype.h>

#include <nwqueue.h>

#include <nwbindry.h>

#include <nwmsg.h>

#include <niterror.h>

#include <nwdir.h>

#include <process.h>

#include <time.h>

#include <nwmisc.h>

#include "../inc/jobdef.h"

#include <nwenvrn.h>

#include <nwdsapi.h>

#include <nwcntask.h>



#define MAXQ 32

#define VERSION "Interactive Queue Manager 1.11"

#define PARAMFILE "DEFAULT"   /* default parameter file name */

#define MAXROW 24

#define MAXJOB 250

#define MAXAGE 60  /* default value for maxAge */

#define MAXOPENAGE 240  /* default value for maxOpenAge */

#define MAXJPS 5 /* maximum of jobs that can be displayed on one screen */

#define ONESEC 1000

#define DEFAULT_CONFIG "SYS:SYSTEM\\IQM.INI"



#define BEEP putchar(7)

#define CLREOL printf("%-78s\r"," ")



typedef struct {

               char filterDesc[64];     // name of filter

               char removeMessage[64];  // remove message

               int (* filterFun ) (long qID, WORD jobNum);

               } FILTER;



typedef struct {

               char queueName[128]; /* its name */

               long queueID;        /* ID of queue */

               int autoDelete;      /* if true, jobs older than maxage will be

                                       automatically deleted */

               long maxAge;         /* maximum age before jobs will be deleted */

               long deleteCount;    /* jobs automatically deleted yet */

               long maxOpenAge;     /* max. age preventing adding jobs from

                                       being killed */

               FILTER *filter;

               } QINFO;





#define MAXFILTER 3

char config[128];



int fNone(long qID, WORD jobNum)

{

return 1;

}



int fPSOnly(long qID, WORD jobNum);

int fNoPS(long qID, WORD jobNum);



FILTER filters[MAXFILTER]={

         {"None", "",   fNone},

         {"PS Only", "Non PS job (%s) removed",fPSOnly},

         {"No PS",   "PS job (%s) removed",fNoPS}

       };



int del=50,    /* delay for screen update in 100 ms units */

    myScreen,  /* screen handle */

    run=FALSE;



NWDSContextHandle   dContext;

WORD conn;

NWCONN_HANDLE connID;

QINFO *theQINFO,qinfo[MAXQ];

int queueCnt=0;



/* read password from console */



char *readpass(void)

{

static char pass[48]="\0";

int i=0;



while (i<48)

  {

  switch (pass[i]=getch()) {

    case 3: return(NULL);

    case 8: if (!i)

              putchar(7);

            else

              {

              printf("\b \b");

              i--;

              }

            break;

    case 13 : pass[i]=0; i=48; break;

    default : if (pass[i]>' ')

                {

                i++;

                putchar('_');

                }

              break;

    }

  }

printf("\n");

return(strupr(pass));

}



/* get local object ID, replaces GetBinderyObjectID */



LONG myGetLocalObjectID(char *oName)

{

WORD connID;

LONG oID=NULL;

int cC;



SetCurrentConnection (-1);

connID = GetCurrentConnection();

cC=NWDSMapNameToID(dContext,connID,oName,&oID);

ReturnConnection(connID);

return cC ? NULL : oID;

}



/* map local object ID to object name, replacement for GetBinderyObjectName */



char *myMapLocalObjectIDToName(LONG ID)

{

WORD connID;

static char name[256];

int cC;



SetCurrentConnection (-1);

connID = GetCurrentConnection();

cC=NWDSMapIDToName(dContext,connID,ID,name);

ReturnConnection(connID);

return cC ? "unknown" : name;

}



/* read in long integer without scanf */



long getlong(void)

{

char x[32];

*x=0;

fgets(x,32,stdin);

return(atol(x));

}



/* get filter number */



int getFilterNum(FILTER *f)

{

int i;

for (i=0;i<MAXFILTER;i++)

  if (filters[i].filterFun==f->filterFun)

    return i;

return 0;

}



/* Functions for loading and writing parameters from and to file

   Format of parameter file:

   #REFRESH=<value>

   #QUEUE=<queuename>,<maxage>,<autodelete>,<maxopenage>,<filter>

   any line which starts not with #QUEUE or #REFRESH is ignored */



#define KEY_QUEUE "QUEUE"

#define KEY_REFRESH "REFRESH"

#define KEY_USER "USER"

#define DELIM "\n\r\t, "



/* load parameter from file */



int loadParameter(char *cf)

{

char tmp[128],*user,*p,*qn,*ma,*ad,*de,*moa,*fn,*dnps;

int i;

FILE *param;

QINFO *qi;



if ((param=fopen(cf,"r"))==NULL)

  return(-1);

while (!feof(param)) {

  if (fgets(tmp,128,param)==NULL)

    break;

  if (tmp[0]=='#')  /* parameter ? */

    if (p=strtok(tmp+1,"="))

      {

      if (!stricmp(p,KEY_REFRESH))

        {

        if (de=strtok(NULL,DELIM))

          {

          del=atoi(de)*10;

          del= del ? del : 50;

          }

        }

      else

      if (!stricmp(p,KEY_USER))

        {

        if (user=strtok(NULL,DELIM))

          {

          printf("Enter password for user %s: ",user);

          p=readpass();

          printf("%x\n",NWDSLogin(dContext,0,user,p,0));

          }

        }

      else

        if (!stricmp(p,KEY_QUEUE))

          {

          if (qn=strtok(NULL,DELIM))

            if (ma=strtok(NULL,DELIM))

              if (ad=strtok(NULL,DELIM))

                if (moa=strtok(NULL,DELIM))

                  if (fn=strtok(NULL,DELIM))

                    {

                    qi=&qinfo[queueCnt];

                    if (qi->queueID=LongSwap(myGetLocalObjectID(qn)))

                      {

                      queueCnt++;

                      //if (NWDSAbbreviateName(dContext,qn,qi->queueName))

                      strcpy(qi->queueName,qn);

                      qi->maxAge=atol(ma);

                      qi->autoDelete=atoi(ad);

                      qi->maxOpenAge=atol(moa);

                      qi->filter=&filters[0];

                      if (atol(fn) && atol(fn)<MAXFILTER)

                        qi->filter=&filters[atol(fn)];

                      if (queueCnt>=MAXQ)

                        break;

                      }

                    }

          }

      }

    }

fclose(param);

return(0);

}



/* save parameter to file */



int writeParameter(char *filename,QINFO *q)

{

FILE *param;

int i;

if ((param=fopen(filename,"w"))==NULL)

  return(-1);

fprintf(param,"%s Parameter File\n",VERSION);

fprintf(param,"Syntax: #QUEUE=<queuename>,<maxage>,<autodel flag>,<maxopenage>,<filter num>\n");

fprintf(param,"#%s=%d\n",KEY_REFRESH,del/10);

for (i=0;i<MAXQ;i++,q++)

  {

  if (q->queueID==NULL)

    break;

  fprintf(param,"#%s=%s,%ld,%i,%i,%i\n",KEY_QUEUE,q->queueName,q->maxAge,

          q->autoDelete,q->maxOpenAge,getFilterNum(q->filter));

  }

fclose(param);

return(0);

}



/* Calculate the difference between currend time and job entry time in minutes.

   Only day, hour and minute are used, so the maximum age must be

   within 31 days */



long jobAge (BYTE *eT)

{

BYTE fsdt[7];

GetFileServerDateAndTime(fsdt);

return(abs((long)eT[2]*1440+(long)eT[3]*60+eT[4]-

            (long)fsdt[2]*1440-(long)fsdt[3]*60-fsdt[4]));

}



/* remove job if older than maxage */



void removeOldJob(QINFO *q,WORD jobNumber)

{

NWQJobRec_t job;



if (NWQGetJobEntry(q->queueID,jobNumber,&job))

  return;



/* leave open jobs in queue if age < maxOpenAge */

if (job.job.controlFlags & QF_ENTRY_OPEN)

  if (jobAge(&job.job.entryTime.year)<q->maxOpenAge)

    return;



if (jobAge(&job.job.entryTime.year)>q->maxAge)

  if (!RemoveJobFromQueue(q->queueID,jobNumber))

    q->deleteCount++;

}



/* remove job not matching filter */



int removeFilteredJob(long queueID,WORD jobNumber,char *message)

{

NWQJobRec_t job;

char tmp[128];

WORD station[1];

BYTE result[1];



if (NWQGetJobEntry(queueID,jobNumber,&job))

  return 42;

if (job.job.controlFlags & QF_ENTRY_OPEN) /* leave open jobs in queue */

  return 42;

station[0]=job.client.clientConnNum;

if (!RemoveJobFromQueue(queueID,jobNumber))

  {

  sprintf(tmp,message,job.textJobDescription);

  SendBroadcastMessage(tmp,station,result,1);

  return 0;

  }

}



/* The auto delete thread runs every 30 seconds */



void autoDeleteThread(QINFO *q)

{

int i;

WORD jobCount,jobList[MAXJOB];



while (run)

  {

  for (i=0;(i<30) && run; i++)

    delay(ONESEC);

  if (q->autoDelete || q->filter)

    if (!GetQueueJobList(q->queueID,&jobCount,jobList,MAXJOB))

      {

      for (i=0;i<jobCount;i++)

        if (q->autoDelete)

          {

          removeOldJob(q,jobList[i]);

          if (!(q->filter->filterFun)(q->queueID,jobList[i]))

            {

            if (!removeFilteredJob(q->queueID,jobList[i],q->filter->removeMessage))

              q->deleteCount++;

            }

          }

      }

  }

}



/* main help screen */



void mainhelp(void)

{

clrscr();

printf("%s Main help screen\n\n",VERSION);

printf("h:       Display this help screen\n");

printf("L:       Load configuration from file\n");

printf("q:       Quit\n");

printf("r:       Refresh screen\n");

printf("SN:      Set new filename for configuration\n");

printf("SR:      Set new screen refresh value\n");

printf("W:       Write configuration to file\n");

printf("+/-:     Select next/previous 8 queues\n");

printf("0 .. 7 : Show detailed info and manage queue jobs\n");

printf("\n");

PressAnyKeyToContinue();

}



/* prompt and return pressed key if key was in select or 0 else */



char userprompt(char *prompt,char *select)

{

char *p=select;

BYTE save[160]; /* buffer for one line */

CopyFromScreenMemory(1,80,save,0,MAXROW);

gotoxy(0,MAXROW); printf("%-70s\r%s ("," ",prompt);

while (*p)

  {

  printf("%c",*p++);

  if (*p)

    printf("/");

  }

printf(")? ");

p=strchr(select,getch());

CopyToScreenMemory(1,80,save,0,MAXROW);

if (p)

  return(*p);

else

  return(0);

}



/* display manage help screen */



void managehelp(QINFO *q)

{

clrscr();

printf("%s Manage help screen\n\n",VERSION);

printf("DQ:      Disable current queue\n");

printf("DS:      Disable print server for current queue\n");

printf("EQ:      Enable current queue\n");

printf("ES:      Enable print server for current queue\n");

printf("F:       Free a held job\n");

printf("h:       Display this help screen\n");

printf("H:       Hold jobs\n");

printf("K:       Kill jobs\n");

printf("P :      Change job Position\n");

printf("q:       Return to main screen\n");

printf("r:       Refresh screen\n");

printf("SA:      Set maximum job age before deleting (current: %ld min)\n",q->maxAge);

printf("SD:      Set auto deletion of old jobs (current: %s)\n",q->autoDelete ? "ON" : "OFF");

printf("SF:      Set filter type for jobs (current: %s)\n",q->filter->filterDesc);

printf("SO:      Set maximum age for open jobs before deleting (current: %ld min)\n",q->maxOpenAge);

printf("v:       View first 256 bytes of print job\n");

printf("+/- :    Display next or previos %d jobs\n",MAXJPS);

printf("0 .. 7 : Switch to other queue\n");

printf("\n");

PressAnyKeyToContinue();

}



/* convert queue status byte to string */



char *qstatstr(BYTE stat)

{

static char s[128];

*s=0;

if (!stat)

  strcpy(s,"[Ready]");

else

  {

  strcpy(s,"[");

  if (stat & QS_CANT_ADD_JOBS)

    strcat(s,"Adding disabled ");

  if (stat & QS_SERVERS_CANT_ATTACH)

    strcat(s,"No server attach ");

  if (stat & QS_CANT_SERVICE_JOBS)

    strcat(s,"No service");

  strcat(s,"]");

  }

return(s);

}



/* print queue status */



int qstatus(QINFO *q)

{

BYTE jobCnt,qStat,servCnt;



printf("Queue %s\n %s (>%ld min), filter: %s, deleted: %ld\n",

        q->queueName,q->autoDelete ? "Autodel" : "No Autodel",q->maxAge,

        q->filter->filterDesc,q->deleteCount);



if (!ReadQueueCurrentStatus(q->queueID,&qStat,&jobCnt,&servCnt,NULL,NULL,0))

      printf("   Status %s, %3d job(s)\n",

             qstatstr(qStat),jobCnt);

return qStat;

}



int     printJobInfo(long queueID,WORD jobNumber)

{

char    *userName;

WORD    oType;

long    fileSize;

BYTE    *b;

int     jobOpen,cC;



NWQJobRec_t job;



jobOpen=0;

CLREOL; printf("Job %d",jobNumber);

if (NWQGetJobEntry(queueID,jobNumber,&job))

  printf(":\n");

else

  {

  b=(BYTE *) &job.job.entryTime.year;

  printf(" [%3d]:",job.job.position);

  if (userName=myMapLocalObjectIDToName(LongSwap(job.client.id)))

    {

    printf(" User %s, ",userName);

    printf("%d.%d.%02d %d:%02d.%02d (age: %ld min) ",b[2],b[1],b[0],b[3],b[4],b[5],

    jobAge(&job.job.entryTime.year));

    }

  if (job.jobServer.id != NULL)

    printf("[active] ");

  else

    if (! (job.job.controlFlags & ~0x1f) )

      printf("[ready] ");

  if (job.job.controlFlags & QF_ENTRY_OPEN)

    {

    printf("[adding] ");

    jobOpen = 1;

    }

  if (job.job.controlFlags & QF_USER_HOLD)

    printf("[user hold] ");

  if (job.job.controlFlags & QF_OPERATOR_HOLD)

    printf("[op. hold] ");

  if ((theQINFO->filter->filterFun)(queueID,jobNumber))

    printf("OK");

  else

    printf("Bad");

  printf("\n"); CLREOL;

  if (! GetQueueJobsFileSize(queueID,jobNumber,&fileSize))

    printf("   (%s) %ld byte(s) %d copies (pjf: %02X)\n",job.textJobDescription,fileSize,

    IntSwap(((CRA*)job.jobServerRecord)->nrOfCopies),

    ((CRA*)job.jobServerRecord)->printFlags);

  }

return job.job.controlFlags; //jobOpen;

}



/* kill non open job from queue */



void killjob(QINFO *q,WORD jobNumber)

{

NWQJobRec_t job;

if (NWQGetJobEntry(q->queueID,jobNumber,&job))

  return;

if (job.job.controlFlags & QF_ENTRY_OPEN)

  if (jobAge(&job.job.entryTime.year)<q->maxOpenAge)

    return;

RemoveJobFromQueue(q->queueID,jobNumber);

}



/* set job to operator hold */



void holdjob(long queueID,WORD jobNumber)

{

NWQJobRec_t job;

if (NWQGetJobEntry(queueID,jobNumber,&job))

  return;

job.job.controlFlags |= QF_OPERATOR_HOLD;

NWQChangeJobEntry(queueID,&job);

}



/* remove operator hold from job */



void freejob(long queueID,WORD jobNumber)

{

NWQJobRec_t job;

if (NWQGetJobEntry(queueID,jobNumber,&job))

  return;

job.job.controlFlags &= ~QF_OPERATOR_HOLD;

NWQChangeJobEntry(queueID,&job);

}



/* view first 256 byte of non active job */



void viewjob(long queueID,WORD jobNumber)

{

NWQJobRec_t job;

char tmp[256],qdir[128],qname[48];

int i,j,n;

FILE *f;

WORD qType;



if (GetBinderyObjectName(queueID,(char *)qname,&qType))

  return;

if (ReadPropertyValue(qname,qType,"Q_DIRECTORY",1,qdir,NULL,NULL))

  return;

if (NWQGetJobEntry(queueID,jobNumber,&job))

  return;

sprintf(tmp,"%s\\%s",qdir,job.job.assocFileName);

if (f=fopen(tmp,"rb"))

  {

  clrscr();

  n=fread(tmp,1,256,f);

  for (i=0;i<n;i+=16)

    {

    printf("\n%04X: ",i);

    for (j=0;j<16;j++)

      printf("%02X ",(BYTE) tmp[i+j]);

    for (j=0;j<16;j++)

      printf("%c",tmp[i+j]>31 ? tmp[i+j] : '.');

    }

  fclose(f);

  printf("\n\n");

  PressAnyKeyToContinue();

  }

}



void setFilter(QINFO *q)

{

int i,f;

clrscr();

printf("Select filter type\n\n");

for (i=0;i<MAXFILTER;i++)

  printf("%d: %s\n",i,filters[i].filterDesc);

f=getlong();

if (f>=0 && f<MAXFILTER)

  q->filter=&filters[f];

}



/* return true if job file contains postscript */



int isPSjob(long queueID,WORD jobNumber)

{

NWQJobRec_t job;

char tmp[256],qdir[128],qname[48],*p;

int isPS=1;

FILE *f;

WORD qType;



if (GetBinderyObjectName(queueID,(char *)qname,&qType))

  return isPS;

if (ReadPropertyValue(qname,qType,"Q_DIRECTORY",1,qdir,NULL,NULL))

  return isPS;

if (NWQGetJobEntry(queueID,jobNumber,&job))

  return isPS;

sprintf(tmp,"%s\\%s",qdir,job.job.assocFileName);

if (f=fopen(tmp,"rb"))

  {

  *tmp=0;

  fread(tmp,1,256,f);

  fclose(f);

  isPS=0;

  if (p=strtok(tmp,"\004\n\r"))

    if (!strncmp(p,"%!",2))

      isPS=1;

  }

return isPS;

}



int fPSOnly(long qID, WORD jobNum)

{

return isPSjob(qID,jobNum);

}



int fNoPS(long qID, WORD jobNum)

{

return !isPSjob(qID,jobNum);

}



/* Display full information and manage queue jobs */



void manageQueue(QINFO *q)

{

int i,firstJob=0,j,prompt;

char c;

WORD jobCount,jobList[MAXJOB];

time_t t;

long l;

int qStat;



do {

  CheckIfScreenDisplayed(myScreen,TRUE);  /* wait until screen is displayed */

  clrscr();

  time(&t);

  printf("Current time : %s",ctime(&t));

  qStat=qstatus(q);

  if (!GetQueueJobList(q->queueID,&jobCount,jobList,MAXJOB))

    {

    if (jobCount<=firstJob)

      firstJob=max(0,firstJob-MAXJPS);

    for (i=firstJob;i<firstJob+MAXJPS;i++)

      if (i<jobCount)

        printJobInfo(q->queueID,jobList[i]);

    }

  gotoxy(0,MAXROW);

  printf("q=return to main, h=Help, r=refresh screen (default is every %d s)",del/10);

  for (i=0;i<del;i++)

    {

    delay(100);

    if (kbhit())

      switch (/*toupper*/(c=getch())) {

        case 'D' : c=userprompt("Disable Queue, Server","QS");

          {

          switch (c) {

          case 'Q' : if (userprompt("Disable Queue","YN")=='Y')

                     {

                     SetQueueCurrentStatus(q->queueID,QS_CANT_ADD_JOBS);

                     i=del;

                     }

                   break;

          case 'S' : if (userprompt("Disable Server","YN")=='Y')

                     {

                     SetQueueCurrentStatus(q->queueID,QS_CANT_SERVICE_JOBS);

                     i=del;

                     }

                   break;

                   }

           break;

           }

        case 'E' : c=userprompt("Enable Queue, Server","QS");

          {

          switch (c) {

          case 'Q' : if (userprompt("Enable Queue","YN")=='Y')

                     {

                     SetQueueCurrentStatus(q->queueID,qStat & ~QS_CANT_ADD_JOBS);

                     i=del;

                     }

                   break;

          case 'S' : if (userprompt("Enable Server","YN")=='Y')

                     {

                     SetQueueCurrentStatus(q->queueID,qStat & ~QS_CANT_SERVICE_JOBS);

                     i=del;

                     }

                   break;

                   }

           break;

           }

        case 'K' : for (j=firstJob,prompt=1;j<jobCount;j++)

                     {

                     if (prompt)

                       {

                       gotoxy(0,20);

                       printJobInfo(q->queueID,jobList[j]);

                       c=userprompt("Kill job(s)","YNAQ");

                       if (c=='Q')

                         break;

                       if (c=='A')

                         {

                         killjob(q,jobList[j]);

                         prompt=0;

                         }

                       if (c=='Y')

                         killjob(q,jobList[j]);

                       }

                     else

                       killjob(q,jobList[j]);

                     }

                   i=del; break;

        case 'P' : printf("\rEnter job number: ");

                   l=getlong();

                   printf("\rEnter new position: ");

                   NWQChangeJobPosition(q->queueID,l,getlong());

                   i=del;

                   break;



        case 'F' : for (j=firstJob,prompt=1;j<jobCount;j++)

                     {

                     if (prompt)

                       {

                       gotoxy(0,20);

                       printJobInfo(q->queueID,jobList[j]);

                       c=userprompt("Free job(s)","YNAQ");

                       if (c=='Q')

                         break;

                       if (c=='A')

                         {

                         freejob(q->queueID,jobList[j]);

                         prompt=0;

                         }

                       if (c=='Y')

                         freejob(q->queueID,jobList[j]);

                       }

                     else

                       freejob(q->queueID,jobList[j]);

                     }

                   i=del; break;

        case 'H' : for (j=firstJob,prompt=1;j<jobCount;j++)

                     {

                     if (prompt)

                       {

                       gotoxy(0,20);

                       printJobInfo(q->queueID,jobList[j]);

                       c=userprompt("Hold job(s)","YNAQ");

                       if (c=='Q')

                         break;

                       if (c=='A')

                         {

                         holdjob(q->queueID,jobList[j]);

                         prompt=0;

                         }

                       if (c=='Y')

                         holdjob(q->queueID,jobList[j]);

                       }

                     else

                       holdjob(q->queueID,jobList[j]);

                     }

                   i=del; break;

        case 'v' : for (j=firstJob,prompt=1;j<jobCount;j++)

                     {

                     if (prompt)

                       {

                       gotoxy(0,20);

                       printJobInfo(q->queueID,jobList[j]);

                       c=toupper(userprompt("View job","YNQ"));

                       if (c=='Q')

                         break;

                       if (c=='Y')

                         viewjob(q->queueID,jobList[j]);

                       }

                     else

                       viewjob(q->queueID,jobList[j]);

                     }

                   i=del; break;

        case 'q' : return;

        case 'r' : i=del; break;

        case 'S' : switch (c=userprompt("Set what","ADFO")) {

                     case 'D':

                       {

                       switch (userprompt("Set auto deletion","01Q")) {

                         case '0' : q->autoDelete=FALSE; break;

                         case '1' : q->autoDelete=TRUE; break;

                         }

                       break; // 'D'

                       }

                     case 'F':

                       {

                       setFilter(q);

                       break; // 'D'

                       }

                     case 'A':

                       {

                       gotoxy(0,MAXROW); CLREOL;

                       printf("Enter maximum age: ");

                       if (l=getlong())

                         q->maxAge=l;

                       break; // 'A'

                       }

                     case 'O':

                       {

                       gotoxy(0,MAXROW); CLREOL;

                       printf("Enter maximum age for open jobs: ");

                       if (l=getlong())

                         q->maxOpenAge=l;

                       break; // 'A'

                       }

                   } // 'S'

                   i=del; break;

        case 'h' : managehelp(q); i=del; break;

        case '+' : if ((firstJob+MAXJPS)<jobCount)

                     {

                     firstJob+=MAXJPS; i=del;

                     }

                   break;

        case '-' : if (firstJob)

                     {

                     firstJob-=MAXJPS; i=del;

                     }

                   break;

        default: if (isdigit(c)) { ungetch(c); return; }

           BEEP;

        }

    }

  } while (1);

}



void main(int argc,char *argv[])

{

int     sCC,i,n,firstQueue=0;

long    l;

char    c,screenName[80],dummy[16],nContext[256];

QINFO   *q;



dContext = NWDSCreateContext( );

// if (!NWDSGetContext(dContext, DCK_NAME_CONTEXT, (void *)nContext));

if (argc==1)

  strcpy(config,DEFAULT_CONFIG);

else

  sprintf(config,"SYS:SYSTEM\\%s\.IQM",argv[1]);

sprintf(screenName,"%s Screen",VERSION);

if ((myScreen=CreateScreen(screenName,AUTO_DESTROY_SCREEN))==EFAILURE)

  {

  NWDSFreeContext(dContext);

  return;

  }

DisplayScreen(myScreen);

if (loadParameter(config))

  {

  ConsolePrintf("Error opening INI file %s\n",config);

  NWDSFreeContext(dContext);

  return;

  }



if (!queueCnt)

  {

  printf("No queues found\n");

  PressAnyKeyToContinue();

  NWDSFreeContext(dContext);

  return;

  }

qsort(qinfo,queueCnt,sizeof(QINFO),stricmp);



del = del ? del : 50;

for (i=0;i<queueCnt;i++)

if (BeginThread(autoDeleteThread,NULL,4096,&qinfo[i])==EFAILURE)

  {

  printf("Error creating thread for queue %s\n",qinfo[i].queueName);

  PressAnyKeyToContinue();

  return;

  }



run=TRUE;



do {

  CheckIfScreenDisplayed(myScreen,TRUE);  /* wait until screen is displayed */

  clrscr();

  printf("%s Main Screen, param file: %s\n\n",VERSION,config);

  for (i=firstQueue,q=qinfo+firstQueue;i<min(queueCnt,firstQueue+8);i++,q++)

    {

    /* gotoxy(0,i*2); */

    printf("%d%d:",i/8,i%8); qstatus(q);

    }

  gotoxy(0,MAXROW);

  printf("q=end, h=Help, r=refresh screen (default is every %d s)",del/10);

  for (i=0;i<del;i++)

    {

    delay(100);

    if (kbhit())

      switch (/*toupper*/(c=getch())) {

        case 'h' : mainhelp(); i=del; break;

        case 'L' : if (userprompt("Load parameters from file","YN")=='Y')

                     if (loadParameter(config))

                       BEEP;

                   i=del; break;

        case 'q' : {

          if (userprompt("Quit","YN")=='Y')

            {

            run=FALSE; i=del;

            }

          break;

          }

        case 'r' : i=del; break;

        case 'S' : switch(userprompt("Set what","NR")) {

                     case 'N' : {

                                gotoxy(0,MAXROW); CLREOL;

                                printf("Enter new file name: ");

                                if (!fgets(config,10,stdin))

                                  strcpy(config,PARAMFILE);

                                else

                                  strtok(strupr(config),"\n\r");

                                i=del;

                                } break;

                     case 'R' : {

                                gotoxy(0,MAXROW); CLREOL;

                                printf("Enter new refresh value: ");

                                if (l=getlong())

                                  del=(int)l*10;

                                i=del;

                                } break;

                             } break;

        case 'W' : if (userprompt("Write parameters to file","YN")=='Y')

                     if (writeParameter(config,qinfo))

                       BEEP;

                   i=del; break;

        case '+' : if (firstQueue+8<queueCnt) { firstQueue+=8; i=del;}

                     break;

        case '-' : if (firstQueue) { firstQueue-=8; i=del;}

                     break;

        default: if (isdigit(c) && (c<'8'))

          {

          n=firstQueue+(c & 0x7);

          if (n<queueCnt)

            {

            theQINFO=&qinfo[n];

            manageQueue(&qinfo[n]);

            i=del;

            }

          else

            BEEP;

          }

        else

          BEEP;

        }

    }

  } while (run);

NWDSLogout(dContext);

NWDSFreeContext(dContext);

// ReturnConnection(connID);

}

