#define N_PLAT_NLM



#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <nwdsapi.h>

#include <nwdserr.h>

#include <nwdsdc.h>

#include <nwdsasa.h>

#include <nwdsdsa.h>

#include <nwdsbuft.h>

#include <nwdsfilt.h>

#include <nwdsdefs.h>

#include <conio.h>



#ifndef FALSE

#define FALSE 0

#endif



#ifndef pBuf_T

typedef NWDS_BUFFER * pBuf_T;

#endif



#define DEBUGINFO

#ifndef nuint32

#define nuint32 int

#endif



//printf("%d\n",__LINE__); getch();



char    *progName;

static  char gtmp[256];

NWDSContextHandle   dContext;

void myNWDSCanonicalizeName(char *shortName, char *canName);

void myNWDSAbbreviateName(char *longName, char *shortName);

int readAttribute(char *objectName,char *aName);

int quietMode=0;



void usage(char *msg)

{

printf("%sUsage: %s -option[q] objectname attribute [value]\n",msg,progName);

printf("Options: \n");

printf("  a : add a new value (append) to attribute\n");

printf("  A : add new attribute and value to objectname\n");

printf("  d : delete value from attribute\n");

printf("  D : delete attribute from objectname\n");

printf("  r : read attribute of objectname\n");

printf("  w : write a new value (replace) to attribute\n");

printf("  q : quiet mode");

exit(0);

}



void myNWDSAbbreviateName(char *longName, char *shortName)

{

char *p;

strcpy(gtmp,longName);

p=strchr(gtmp,0)-1;

while (*p=='.') *p--=0;

NWDSAbbreviateName(dContext,gtmp,shortName);

printf("%s->%s\n",gtmp,shortName);

}



/* get current context and convert it e.g. rz.uni-regensburg.de -> ou=rz.o=uni-regensburg.c=de */



void getConvertedContext(char *con2, int useCountry)

{

int i,parts,oLevel;

char *p;

static char tmp[MAX_DN_CHARS];

char con1[MAX_DN_CHARS];



*con2=0;



if (NWDSGetContext(dContext, DCK_NAME_CONTEXT, con1))

  return;

for (parts=1,p=strchr(con1,'.');p;parts++,p=strchr(p+1,'.'));

if (useCountry)

  oLevel=parts-1;

else

  oLevel=parts;

strcpy(tmp,con1);

for (i=1,p=strtok(tmp,".");i<=parts;i++,p=strtok(NULL,"."))

  {

  if (i>oLevel)

    strcat(con2,".C=");

  else

    if (i==oLevel)

      strcat(con2,".O=");

    else

      if (i>1)

        strcat(con2,".OU=");

      else

        strcat(con2,"OU=");

  strcat(con2,p);

  }

}



//  ....OU=xx.O=de -> ...O=xx.C=de



void myNWDSCanonicalizeName(char *shortName, char *canName)

{

char *p,*p0;

NWDSCanonicalizeName(dContext,shortName, canName+1);

*canName='.';

if (p=strrchr(canName,'.'))

  if (!strnicmp(p+1,"O=",2))

    {

    p0=p;

    *(p+1)='C';

    *p=0;

    p=strrchr(canName,'.');

    *p0='.';

    memmove(p+2,p+3,strlen(p+3)+1);

    }

}



void getprogname(char *argv0)

{

char *p1;

if ((p1=strrchr(argv0,'.'))!=NULL)

  *p1=0;

if ((p1=strrchr(argv0,'\\'))!=NULL)

  progName=p1+1;

else

  progName=argv0;

}



/* return pointer to attribut value */



char *makePointer(int valc,char *aVal[],nuint32 syntax)

{

static BYTE vBuf[512];

char *p=vBuf;

EMail_Address_T *pEMail;

Path_T *pPath;



switch (syntax) {

  case  SYN_UNKNOWN: p=NULL; break;

  case  SYN_DIST_NAME: myNWDSCanonicalizeName(aVal[0],p); break;

  case  SYN_CE_STRING: p=aVal[0]; break;

  case  SYN_CI_STRING: p=aVal[0]; break;

  case  SYN_PR_STRING: p=aVal[0]; break;

  case  SYN_NU_STRING: p=aVal[0]; break;

  case  SYN_CI_LIST: p=NULL; break;

  case  SYN_BOOLEAN: vBuf[0]=*aVal[0]=='1' ? 1:0; p=vBuf; break;

  case  SYN_INTEGER: *(uint32 *)vBuf=atol(aVal[0]); break;

  case  SYN_OCTET_STRING: p=NULL; break;

  case  SYN_TEL_NUMBER: p=NULL; break;

  case  SYN_FAX_NUMBER: p=NULL; break;

  case  SYN_NET_ADDRESS: p=NULL; break;

  case  SYN_OCTET_LIST: p=NULL; break;

  case  SYN_EMAIL_ADDRESS: p=NULL;

                           if (valc>1)

                             {

                             *p=0;

                             pEMail=(EMail_Address_T *)vBuf;

                             pEMail->type=atol(aVal[0]);

                             pEMail->address=aVal[1];

                             p=vBuf;

                             }

                           break;

  case  SYN_PATH: p=NULL; if (valc<3) return p;

                  pPath=(Path_T *)vBuf;

                  pPath->nameSpaceType=atol(aVal[0]);

                  pPath->volumeName=aVal[1];

                  pPath->path=aVal[2];

                  p=pPath;

                  break;

  case  SYN_REPLICA_POINTER: p=NULL; break;

  case  SYN_OBJECT_ACL: p=NULL; break;

  case  SYN_PO_ADDRESS: p=NULL; break;

  case  SYN_TIMESTAMP: p=NULL; break;

  case  SYN_CLASS_NAME: p=NULL; break;

  case  SYN_STREAM: p=NULL; break;

  case  SYN_COUNTER: *(uint32 *)vBuf=atol(aVal[0]); break;

  case  SYN_BACK_LINK: p=NULL; break;

  case  SYN_TIME: p=NULL; break;

  case  SYN_TYPED_NAME: p=NULL; break;

  case  SYN_HOLD: p=NULL; break;

  case  SYN_INTERVAL: p=NULL; break;

  case  SYNTAX_COUNT: *(uint32 *)vBuf=atol(aVal[0]); break;

  }

return p;

}



void dispValue(char *aVal,nuint32 syntax)

{

static BYTE vBuf[512];

char *p=vBuf;



EMail_Address_T *pEMail;

Path_T *pPath;



static char *EMail_Types[2]={"Foreign Email Address","Foreign Email Alias"};

switch (syntax) {

  case  SYN_UNKNOWN: p=NULL; break;

  case  SYN_DIST_NAME: p=aVal; break;

  case  SYN_CE_STRING: p=aVal; break;

  case  SYN_CI_STRING: p=aVal; break;

  case  SYN_PR_STRING: p=aVal; break;

  case  SYN_NU_STRING: p=aVal; break;

  case  SYN_CI_LIST: p=NULL; break;

  case  SYN_BOOLEAN:

  case  SYN_COUNTER:

  case  SYN_INTEGER: sprintf(p,"%ld",*(uint32 *)(aVal)); break;

  case  SYNTAX_COUNT: sprintf(p,"%lu",*(uint32 *)(aVal)); break;

  case  SYN_OCTET_STRING: p=NULL; break;

  case  SYN_TEL_NUMBER: p=NULL; break;

  case  SYN_FAX_NUMBER: p=NULL; break;

  case  SYN_NET_ADDRESS: p=NULL; break;

  case  SYN_OCTET_LIST: p=NULL; break;

  case  SYN_EMAIL_ADDRESS:   pEMail=(EMail_Address_T *) aVal;

                             sprintf(p,"%s: %s",EMail_Types[pEMail->type &1],pEMail->address);

                             break;

  case  SYN_PATH: pPath=(Path_T *) aVal;

                  // myNWDSAbbreviateName(pPath->volumeName,vBuf+256);

                  sprintf(p,"%ld %s %s",pPath->nameSpaceType,pPath->volumeName,

                  pPath->path);

                  break;

  case  SYN_REPLICA_POINTER: p=NULL; break;

  case  SYN_OBJECT_ACL: p=NULL; break;

  case  SYN_PO_ADDRESS: p=NULL; break;

  case  SYN_TIMESTAMP: p=NULL; break;

  case  SYN_CLASS_NAME: p=NULL; break;

  case  SYN_STREAM: p=NULL; break;

  case  SYN_BACK_LINK: p=NULL; break;

  case  SYN_TIME: sprintf(p,"%s",ctime((time_t *)aVal)); break;

  case  SYN_TYPED_NAME: p=NULL; break;

  case  SYN_HOLD: p=NULL; break;

  case  SYN_INTERVAL: p=NULL; break;

  }

if (p)

  puts(p);

else

  printf("Values of syntax %d not yet supported\n",syntax);

}



int modifyAttribute(char *objectName,char *aName,int valc,char *aVal[],nuint32 changeType)

{

pBuf_T              buf;

NWDSCCODE           ccode;

nuint32             syntax;

char                *p;



if (valc==0)

  return 42;



if (ccode=NWDSGetSyntaxID(dContext,aName,&syntax))

  {

  fprintf(stderr,"NWDSGetSyntaxID: %x\n",ccode);

  return 42;

  }



if (ccode=NWDSAllocBuf(MAX_MESSAGE_LEN, &buf))

  {

  fprintf(stderr,"NWDSAllocBuf: %x\n",ccode);

  return 42;

  }



if (ccode = NWDSInitBuf(dContext, DSV_MODIFY_ENTRY, buf))

  {

  fprintf(stderr,"NWDSInitBuf: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }



if (changeType==DS_OVERWRITE_VALUE)

  {

  if (ccode = NWDSPutChange(dContext, buf,DS_CLEAR_ATTRIBUTE,aName))

    {

    fprintf(stderr,"NWDSPutChange: %x\n",ccode);

    NWDSFreeBuf(buf);

    return 42;

    }

  changeType=DS_ADD_VALUE;

  }



if (ccode = NWDSPutChange(dContext, buf,changeType,aName))

  {

  fprintf(stderr,"NWDSPutChange: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }



if (changeType==DS_OVERWRITE_VALUE)

if (ccode = NWDSPutChange(dContext, buf,DS_CLEAR_VALUE,aName))

  {

  fprintf(stderr,"NWDSPutChange: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }



if (changeType!=DS_REMOVE_ATTRIBUTE) // && changeType != DS_REMOVE_VALUE)

  {

  p=makePointer(valc,aVal,syntax);

  if (p==NULL)

    {

    fprintf(stderr,"makePointer (syntax %d): ->0\n",syntax);

    NWDSFreeBuf(buf);

    return 42;

    }

  }



if (ccode = NWDSPutAttrVal(dContext,buf,syntax,p))

  {

  fprintf(stderr,"NWDSPutAttrVal: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }



if (ccode = NWDSModifyObject(dContext,(pnstr8)objectName,NULL,(nbool8)0,buf))

  {

  fprintf(stderr,"NWDSModifyObject: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }

NWDSFreeBuf(buf);

readAttribute(objectName,aName);

return 0;

}



int readAttribute(char *objectName,char *aName)

{

pBuf_T              buf,aBuf;

NWDSCCODE           ccode;

nuint32             syntax;

char                *p;

nint32              iterHandle=-1L;

nuint32             totalAttrs, attrValSize, totalValues, x;

char                *attrValue=NULL,attrName[256];



if (ccode=NWDSAllocBuf(MAX_MESSAGE_LEN, &buf))

  {

  fprintf(stderr,"NWDSAllocBuf: %x\n",ccode);

  return 42;

  }



if (ccode=NWDSAllocBuf(DEFAULT_MESSAGE_LEN, &aBuf))

  {

  fprintf(stderr,"NWDSAllocBuf: %x\n",ccode);

  NWDSFreeBuf(buf);

  return 42;

  }



if (ccode = NWDSInitBuf(dContext, DSV_READ, aBuf))

  {

  fprintf(stderr,"NWDSInitBuf: %x\n",ccode);

  NWDSFreeBuf(buf);

  NWDSFreeBuf(aBuf);

  return 42;

  }



if (ccode=NWDSGetSyntaxID(dContext,aName,&syntax))

  {

  fprintf(stderr,"NWDSGetSyntaxID: %x\n",ccode);

  NWDSFreeBuf(buf);

  NWDSFreeBuf(aBuf);

  return 42;

  }



if (ccode = NWDSPutAttrName(dContext,aBuf,aName))

  {

  fprintf(stderr,"NWDSPutAttrName: %x\n",ccode);

  NWDSFreeBuf(buf);

  NWDSFreeBuf(aBuf);

  return 42;

  }



do {

   if (ccode = NWDSRead(dContext,(pnstr8) objectName,DS_ATTRIBUTE_VALUES,

               FALSE,aBuf,&iterHandle,buf))

               break;

   if (NWDSGetAttrCount(dContext,buf,&totalAttrs))

     break;

   if (totalAttrs==0)

     break;

   if (NWDSGetAttrName(dContext,buf,attrName,&totalValues,&syntax))

     break;

   for(x=totalValues;x;x--)

     {

     if (NWDSComputeAttrValSize(dContext,buf,syntax,&attrValSize))

       break;

     if (!attrValue)

       if ((attrValue = malloc((int)attrValSize))==NULL)

         break;

     if (NWDSGetAttrVal(dContext,buf,syntax,attrValue))

       break;

     if (!quietMode)

       dispValue(attrValue,syntax);

     }

   } while (iterHandle != NO_MORE_ITERATIONS);



NWDSFreeBuf(buf);

NWDSFreeBuf(aBuf);

if (attrValue)

  free(attrValue);

return 0;

}





int main1(int argc, char *argv[])

{

NWDSCCODE           ccode=0;

char                *opt,*objectName,*attribName,**attribVal;

static              char oName[256];

int                 valCount;



getprogname(argv[0]);



if (argc<4)

  usage("");



opt=argv[1];

objectName=argv[2];

attribName=argv[3];



//if (argc>4)

attribVal=argv+4; //[4];

valCount=argc-4;

//else

//  attribVal=NULL;



dContext = NWDSCreateContext();



if (*objectName!='.')

  {

  myNWDSCanonicalizeName(objectName,oName);

  // getConvertedContext(strchr(oName,0),1);

  objectName=oName;

  }



//printf("%s %s %s %s\n",opt,objectName,attribName,attribVal ? attribVal : "");



if (*opt=='-')

  {

  quietMode=opt[2]=='q';

  switch (opt[1]) {

    case 'a' : modifyAttribute(objectName,attribName,valCount,attribVal,DS_ADD_VALUE); break;

    case 'A' : modifyAttribute(objectName,attribName,valCount,attribVal,DS_ADD_ATTRIBUTE); break;

    case 'D' : modifyAttribute(objectName,attribName,valCount,attribVal,DS_REMOVE_ATTRIBUTE); break;

    case 'r' : readAttribute(objectName,attribName); break;

    case 'd' : modifyAttribute(objectName,attribName,valCount,attribVal,DS_REMOVE_VALUE); break;

    case 'w' : modifyAttribute(objectName,attribName,valCount,attribVal,DS_OVERWRITE_VALUE);

              break;

    default : usage("Invalid option\n");

    }

  }

else

  usage("Syntax error\n");



NWDSFreeContext(dContext);

return ccode;

}



void setupargs(char *cmdline, int *ac, char **av)

{

int i;

*ac=1; *av="Setup args";

}



int main(int argc, char *argv[])

{

FILE *f;

char cmdline[256],**av;

int ac;



if (argc==1)

  return main1(argc,argv);

if (*argv[1]=='@')

  {

  if ((f=fopen(argv[1]+1,"r"))==NULL)

    {

    printf("Error opening command file %s\n",argv[1]);

    return 1;

    }

  for (;;)

    if (fgets(cmdline,255,f)==NULL)

      break;

    else

      {

      setupargs(cmdline,&ac,&av);

      main1(ac,av);

      }

  fclose(f);

  return 0;

  }

else

  return main1(argc,argv);

}

