/* NNFLAG.C                                                                 */

/* program to delete/change/set attributs                                   */

/* commandline: nflag path attributes [sub]                                 */

/* by G. Boehm 1.10.1992                                                    */



#include <limits.h>

#include <direct.h>

#include <string.h>

#include <stddef.h>

#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <nwdir.h>

#include <nwfile.h>



/* memory allocation for pointers x, z */

char xbf[11], zbf[11], bufferbf[10];

/* memory allocation for array of pointers args */

char argsbfr[30][256];

char *args[30];



/* memory allocation for *_dir pointer */

char pathbfr[1][_MAX_PATH];

char *work_dir, *cwd_bfr;



/* defined values */

char path[_MAX_PATH]="sys:";

char mask[_MAX_NAME] = "*";

char global_switch[3] = "0";



int subdir_scan = 0;

int showflag = 0;

int argsc = 1;



char RO_[3] = "0";

char RW_[3] = "0";

char S_[3] = "0";

char X_[3] = "0";

char H_[3] = "0";

char SY_[3] = "0";

char T_[3] = "0";

char P_[3] = "0";

char A_[3] = "0";

char RA_[3] = "0";

char WA_[3] = "0";

char CI_[3] = "0";

char DI_[3] = "0";

char RI_[3] = "0";



unsigned long attributes = 0x00000000U;



unsigned long getarguments(), setattributes();

void prepeararguments(), showcurrentflag(), scanDirectory();



main(argc, argv)

int argc;

char *argv[];

{

 int i;



 /* initialising of args absolutely necessary */

 for (i = 0; i <= 30; i++ )

   args[i] = &argsbfr[i][0];



/* Initialising of pointers */

 cwd_bfr = &pathbfr[0][0];

 work_dir = &pathbfr[1][0];



 if ( argc > 1 )

   {

    strcpy(path,argv[1]);

    if ( argc > 2)

      {

       for ( i = 2; i < argc; i++)

         {

          if ( strcmp(strlwr(argv[i]),"sub") == 0 )

            subdir_scan = 1;

          else

            {

             strcpy(args[i-2], argv[i]);

             argsc++;

            };

         };

       if ( argc == 3 && subdir_scan == 1 )

         showflag = 1;

      }

    else

      showflag = 1;

   }

 else

   errormessage(argv[0]);



 prepeararguments();

 attributes = getarguments();

 scanDirectory(path); /* recursive if necessary */

}



unsigned long getarguments()

{

 unsigned long a = 0x00000000U;



 if ( strcmp(RO_, "0") != 0 )

   {

    if ( strcmp(RO_, "+1") == 0 )

      {

       a = a | setattributes("+1", _A_NORENAM);

       a = a | setattributes("+1", _A_NODELET);

      }

    else

      {

       a = a | setattributes("-1", _A_NORENAM);

       a = a | setattributes("-1", _A_NODELET);

      };

    a = a | setattributes(RO_, _A_RDONLY);

   }

 else

 if ( strcmp(RW_, "0") != 0 )

   {

    if ( strcmp(RW_, "+1") == 0 )

      {

       a = a | setattributes("-1", _A_NORENAM);

       a = a | setattributes("-1", _A_NODELET);

      }

    else

      {

       a = a | setattributes("+1", _A_NORENAM);

       a = a | setattributes("+1", _A_NODELET);

      };

    a = a | setattributes(RW_, _A_NORMAL);

   };



 if ( strcmp(H_, "0") != 0 )

   a = a | setattributes(H_, _A_HIDDEN);

 if ( strcmp(SY_, "0") != 0 )

   a = a | setattributes(SY_, _A_SYSTEM);

 if ( strcmp(X_, "0") != 0 )

   a = a | setattributes(X_, _A_EXECUTE);

 if ( strcmp(A_, "0") != 0 )

   a = a | setattributes(A_, _A_ARCH);

 if ( strcmp(S_, "0") != 0 )

   a = a | setattributes(S_, _A_SHARE);

 if ( strcmp(T_, "0") != 0 )

   a = a | setattributes(T_, _A_TRANS);

 if ( strcmp(RA_, "0") != 0 )

   a = a | setattributes(RA_, _A_READAUD);

 if ( strcmp(WA_, "0") != 0 )

   a = a | setattributes(WA_, _A_WRITAUD);

 if ( strcmp(P_, "0") != 0 )

   a = a | setattributes(P_, _A_IMMPURG);

 if ( strcmp(RI_, "0") != 0 )

   a = a | setattributes(RI_, _A_NORENAM);

 if ( strcmp(DI_, "0") != 0 )

   a = a | setattributes(DI_, _A_NODELET);

 if ( strcmp(CI_, "0") != 0 )

   a = a | setattributes(CI_, _A_NOCOPY);

 return(a);

}



unsigned long setattributes(s, flag)

char *s;

unsigned flag;

{

 unsigned long a = 0x00000000U;



 printf("s: %s", s);

 if ( strcmp(s, "+1" ) == 0 )

   {

    a = a | flag;

    printf("+flag: 0x%x", a);

   }

 else

   {

    if ( strcmp(s, "-1" ) == 0 )

      {

       a = a & flag;

       printf("-flag: 0x%x", a);

      };

    };

 printf(" = >flag: 0x%x\n", a);

 return(a);

}



void prepeararguments()

{

 int i;



 for ( i = 0; i < argsc; i++ )

   {

    if ( strcmp(args[i], "+") == 0 )

      strcpy(global_switch, "+1");

    else

    if ( strcmp(args[i], "-") == 0 )

      strcpy(global_switch, "-1");

    else

      {

       if ( strcmp(global_switch, "0") == 0 )

          strcpy(global_switch, "+1");

       scanarguments(args[i]);

      };

   };

 printswitches();

 for( i=0; i < argsc; i++)

   printf("args[%i]: %s\n", i, args[i]);

}





printswitches()

{

       printf("RO_Read_Only 1: %s\n", RO_ );

       printf("RW_Read_Write 1: %s\n", RW_ );

       printf("RA_Read_Audit 1: %s\n", RA_ );

       printf("WA_Write_Audit 1: %s\n", WA_ );

       printf("CI_Copy_Inhibit 1: %s\n", CI_ );

       printf("DI_Delete_Inhibit 1: %s\n", DI_ );

       printf("RI_Rename_Inhibit 1: %s\n", RI_ );

       printf("Sy_SYstem 1: %s\n", SY_ );

       printf("S_Sharable 1: %s\n", S_ );

       printf("H_Hidden 1: %s\n", H_ );

       printf("X_eXecute_only 1: %s\n", X_ );

       printf("T_Transactional 1: %s\n", T_ );

       printf("P_Purge 1: %s\n", P_ );

       printf("A_Archive_needed 1: %s\n\n", A_ );

}





void showcurrentflag(f,a)

/*    filename.ext         [ Ro/Rw S A X H Sy T P RA WA CI DI RI ]   */

char *f;

unsigned long a;

{

 char flaglist[35];



 if ( a & _A_RDONLY )

   strcpy(flaglist, "Ro ");

 else /* if ( a & _A_NORMAL )*/

   strcpy(flaglist, "Rw ");

 if ( a & _A_SHARE )

   strcat(flaglist, "S ");

 else

   strcat(flaglist, "- ");

 if ( a & _A_ARCH )

   strcat(flaglist, "A ");

 else

   strcat(flaglist, "- ");

 if ( a & _A_EXECUTE )

   strcat(flaglist, "X ");

 else

   strcat(flaglist, "- ");

 if ( a & _A_HIDDEN )

   strcat(flaglist, "H ");

 else

   strcat(flaglist, "- ");

 if ( a & _A_SYSTEM )

   strcat(flaglist, "Sy ");

 else

   strcat(flaglist, "-- ");

 if ( a & _A_TRANS )

   strcat(flaglist, "T ");

 else

   strcat(flaglist, "- ");

  if ( a & _A_IMMPURG )

   strcat(flaglist, "P ");

 else

   strcat(flaglist, "- ");

 if ( a & _A_READAUD )

   strcat(flaglist, "RA ");

 else

   strcat(flaglist, "-- ");

 if ( a & _A_WRITAUD )

   strcat(flaglist, "WA ");

 else

   strcat(flaglist, "-- ");

 if ( a & _A_NOCOPY )

   strcat(flaglist, "CI ");

 else

   strcat(flaglist, "-- ");

 if ( a & _A_NODELET )

   strcat(flaglist, "DI ");

 else

   strcat(flaglist, "-- ");

 if ( a & _A_NORENAM )

   strcat(flaglist, "RI");

 else

   strcat(flaglist, "--");

 printf("      %s                 [ %s ]\n", f, flaglist);

}



int scanarguments(s)

char *s;

{

 char *value;



 value = "";

 if ( strcmp(s, "" ) == 0 )

   return(0);

 else

   {

    if ( *s == '+' || *s == '-' )            /* what's the first char */

      {

       if ( *s == '+' )

         strcpy(value, "+1");

       else

         strcpy(value, "-1");

       *++s;                                 /* next char */

      }

    else

      {

       strcpy(value, global_switch);

      };

    while( *s != '\0' )                     /* until last char */

      {

       if ( *s == '+' )

         strcpy(value, "+1");

       else

       if ( *s == '-' )

         strcpy(value, "-1");

       else

       if ( *s == 'r' )

         {

          if ( *++s != '\0' )

            {

             if ( *s == 'o' )

               strcpy(RO_, value);

             else

             if ( *s == 'w' )

               strcpy(RW_, value);

             else

             if ( *s == 'a' )

               strcpy(RA_, value);

             else

             if ( *s == 'i' )

               strcpy(RI_, value);

             else

               printf("Invalid switch r%c!\n", *s);

            }

          else

            printf("Invalid switch r!\n");

         }

       else

       if ( *s == 'w' )

         {

          if ( *++s != '\0' )

            {

             if ( *s == 'a' )

               strcpy(WA_, value);

             else

               printf("Invalid switch w%c!\n", *s);

            }

          else

            printf("Invalid switch w !\n");

         }

       else

       if ( *s == 'c' )

         {

          if ( *++s != '\0' )

            {

             if ( *s == 'i' )

               strcpy(CI_, value);

             else

               printf("Invalid switch c%c!\n", *s);

            }

          else

            printf("Invalid switch c !\n");

         }

       else

       if ( *s == 'd' )

         {

          if ( *++s != '\0' )

            {

             if ( *s == 'i' )

               strcpy(DI_, value);

             else

               printf("Invalid switch d%c!\n", *s);

            }

          else

            printf("Invalid switch d !\n");

         }

       else

       if ( *s == 's' )

         {

          if ( *++s != '\0' )

            {

             if ( *s == 'y' )

               strcpy(SY_, value);

             else

               {

                strcpy(S_, value);

                *--s;

               };

            }

          else

            strcpy(S_, value);

         }

       else

       if ( *s == 'h' )

         strcpy(H_, value);

       else

       if ( *s == 'x' )

         strcpy(X_, value);

       else

       if ( *s == 't' )

         strcpy(T_, value);

       else

       if ( *s == 'p' )

         strcpy(P_, value);

       else

       if ( *s == 'a' )

         strcpy(A_, value);

       else

         printf("Invalid switch %c !\n", *s);

      *++s;

      };

    return(1);

   };

}



/*------------------------------------------------------------*/

/*           Directory Stuff of Novell                        */

/*------------------------------------------------------------*/



int fixattributes(file, attribs, newattribs)

char *file;

LONG attribs, newattribs;

{

 struct ModifyStructure   modifyVector;

 LONG modifyBits = MFileAttributesBit;

 LONG allowWildCardsFlag = 0x01U;

 LONG MFileAttributes;



 if ( showflag == 1 )

    showcurrentflag(file, attribs);

 else

   {

    /* filling ModifyStructure */

    MFileAttributes = attribs | newattribs;

    if ( ChangeDirectoryEntry(file, &modifyVector,

              modifyBits, allowWildCardsFlag) != 0)

      {

       printf("Could not set File Attributes for file %s\n", file);

       return(-1);

      };

   };

 return(0);

}



int prepearscandir(path)

/* global variables: char *cwd_dir, *work_dir;  *

 *                                              *

 * changes  cwd_bfr                             */

char *path;

{

 size_t size = 0x01ff;



 getcwd(cwd_bfr, size);  /* store current working dir */

 if (  cwd_bfr != NULL )

   printf("cwd_bfr: %s \n", cwd_bfr);

 else

   return(-2);

 if ( getmask(path) < 0 )

   return(-1);

 else

   return(0);

}



int getmask(path)

/* global variables: char *work_dir;            *

 *                   char mask[_MAX_NAME];      *

 *                                              *

 * changes  mask                                */

char *path;

{

 char drive[_MAX_DRIVE];

 char dir[_MAX_DIR];

 char filenme[_MAX_FNAME];

 char ext[_MAX_EXT];



 _splitpath( path, drive, dir, filenme, ext);    /* split path          */



 if ( strcmp(filenme, "") == 0 )  /* make search mask, default "*" */

   {                              /* change to path directory      */

    strcpy(work_dir, drive);

    strcat(work_dir, ":");

    strcat(work_dir, dir);

    strcat(work_dir, "\\");

    if ( chdir(work_dir) != 0 )

      {

       printf("Could not change to %s Directory !\n", strupr(work_dir));

       return(-1);

      }

   else

     printf("CD %s\n",work_dir);

   }

 else

   {

    strcpy(mask, strupr(filenme));

    if ( strcmp(ext, "") != 0 )

      strcat(mask, strupr(ext));

   };

 return(0);

}



int scandir(path)

/* Global Var: LONG attributes                         *

 * recursive iff subdir_scan == 1                      */

char *path;

{

 DIR *dirp, *direntp;



 char *subDirectory;

 unsigned long searchattributes = 0x06U; /* first search attribute */

                                         /* searching normal system & hidden */



 subDirectory = "";



 if ( (dirp = opendir(strupr(path))) == NULL )

   {

    printf("Path %s NOT found !\n", path);

    return(-1);

   };



 SetReaddirAttribute(dirp, searchattributes);



 if ( showflag == 1)

   printf("Directory %s:\n", work_dir);



 while ( (direntp = readdir(dirp)) != NULL )

    if ( fixattributes(strupr(direntp->d_name),

                       direntp->d_attr, attributes) == 0 );



 if ( subdir_scan == 1 )

   {

    SetReaddirAttribute(dirp, _A_SUBDIR);

    while ( (direntp = readdir(dirp)) != NULL )

      {

       strcpy(subDirectory, direntp->d_name);

       strcat(subDirectory, "\\" );

       strcat(subDirectory, mask );

       if ( scandir(subDirectory) == 0 );

      };

    closedir(dirp);

   }

 else

   closedir(dirp);



 return(0);

}



void scanDirectory(path)

char *path;

{

 int n;

 n = prepearscandir(path);

 if ( n == -2 )

   exit(10);

 else

   {

    if ( n == -1 )

      exit(1);

    else

      {

       if ( scandir(mask) == 0);

       if ( chdir(cwd_bfr) != 0 )

         {

          printf("Could not change to %s Directory !\n", strupr(cwd_bfr));

          exit(2);

         }

       else

         /*free(cwd_bfr)*/;

      };

   };

}





errormessage(name)

char *name;

{

 printf("Wrong number of arguments!\n");

 printf("NFLAG path [[+|-] attribute(s) [sub]]\n");

 printf("      path        of file/directory \n");

 printf("      attributes  to set/change: \n");

 printf("                  RO Read Only \n");

 printf("                  RW Read Write \n");

 printf("                  S  Sharable \n");

 printf("                  H  Hidden \n");

 printf("                  Sy System \n");

 printf("                  T  Transactional \n");

 printf("                  P  Purge \n");

 printf("                  A  Archive Needed \n");

 printf("                  RA Read Audit \n");

 printf("                  WA Write Audit \n");

 printf("                  CI Copy Inhibit \n");

 printf("                  DI Delete Inhibit \n");

 printf("                  RI Rename Inhibit \n");

 printf("      sub         scans also subdirectories \n");

 printf("(c) by Gerd Bhm, October 1992\n");

 exit(1);

}



