#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <nwdsapi.h>

#include <nwdserr.h>

#include <nwdsdc.h>

#include <nwdsasa.h>

#include <nwdsdsa.h>

#include <nwdsbuft.h>

#include <nwdsfilt.h>

#include <nwdsdefs.h>

#include <conio.h>



void main(int argc, char *argv[]) {



NWDSContextHandle   dContext;

NWDS_ITERATION      iterHandle=NO_MORE_ITERATIONS;

NWOBJECT_INFO       objInfo;

NWSYNTAX_ID         syntax;

NWDS_BUFFER         *filter, *outBuf;

NWDS_BUFFER         *cur;

NWCOUNT             totalObj, totalAttr;

NWDSCCODE           ccode;

NWDS_NUM_OBJ        nob;

static char         baseObj[MAX_DN_CHARS];

static char         objClass[MAX_DN_CHARS];

static char         name[MAX_DN_CHARS];

static char         contextBuf[MAX_DN_BYTES];

static char         aname[64],aval[64];

int                 i,n=0;

FILE *f;



SetAutoScreenDestructionMode(1);

if (argc < 3) {

  printf("\nUsage: NSEARCH <base object> <\"object class\"> [attrib value]");

  exit(1);

  }

if ((f=fopen("sys:user\\ph\\tree.out","w"))==NULL)

  f=stdout;

strcpy(objClass, argv[2]);

dContext = NWDSCreateContext( );

if ( dContext == ERR_CONTEXT_CREATION)

  goto _FreeAll;

strcpy(baseObj,strupr(argv[1]));

fprintf(f,"%s\n",baseObj);

ccode = NWDSAllocBuf(DEFAULT_MESSAGE_LEN, &filter);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSAllocBuf(DEFAULT_MESSAGE_LEN, &outBuf);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSInitBuf(dContext, DSV_SEARCH_FILTER, filter);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSAllocFilter((NWDS_FILTER_CURSOR NWFAR * NWFAR *)&cur);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_ANAME,

                           "Object Class", SYN_CLASS_NAME);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_EQ,NULL,

        (NWSYNTAX_ID)0);

if(ccode < 0)

   goto _FreeAll;

ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur,FTOK_AVAL,objClass,

       SYN_CLASS_NAME);

if(ccode < 0)

  goto _FreeAll;

if (argc>4)  /* search for attribute in argv[3] equal to pattern in argv[4] */

  {

  strcpy(aname,strupr(argv[3]));

  strcpy(aval,strupr(argv[4]));

  if (NWDSGetSyntaxID(dContext,aname,&syntax)<0)

    syntax=SYN_CI_STRING;

  ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_AND,NULL,

        (NWSYNTAX_ID)0);

  if(ccode < 0)

     goto _FreeAll;

  ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_ANAME,

                           aname, syntax);

  if(ccode < 0)

    goto _FreeAll;

  ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_APPROX,NULL,

        (NWSYNTAX_ID)0);

  if(ccode < 0)

     goto _FreeAll;

  ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur,FTOK_AVAL,aval,

       syntax);

  if(ccode < 0)

    goto _FreeAll;

  }

ccode = NWDSAddFilterToken((NWDS_FILTER_CURSOR NWFAR *)cur, FTOK_END,

        NULL, (NWSYNTAX_ID)0);

if(ccode < 0)

  goto _FreeAll;

ccode = NWDSPutFilter(dContext, filter,(NWDS_FILTER_CURSOR NWFAR *)cur,NULL);



if(ccode < 0)

    goto _FreeAll;

fprintf(f,"\n\"%s\" objects under %s:", objClass, argv[1]);

do {

   ccode = NWDSSearch(dContext,

                      baseObj,

                      DS_SEARCH_SUBTREE,

                      FALSE,   /* no aliases */

                      filter,

                      DS_ATTRIBUTE_VALUES,

                      FALSE,

                      NULL,

                      &iterHandle,

                      0,

                      (NWDS_NUM_OBJ NWFAR *)&nob,

                      outBuf);

  if(ccode < 0)

    goto _FreeAll;

  ccode = NWDSGetObjectCount(dContext, outBuf, &totalObj);

  if(ccode < 0)

    goto _FreeAll;

  if(totalObj == 0 && n == 0)

    {

    fprintf(f,"\n<None found>", objClass);

    goto _FreeAll;

    }

  n++;

  for(i = 0; i < totalObj; i++)

    {

    ccode = NWDSGetObjectName(dContext, outBuf, name, &totalAttr,&objInfo);

    if(ccode < 0)

      goto _FreeAll;

    if (ccode=NWDSCanonicalizeName(dContext,name,contextBuf))

      fprintf(f,"\n %x %s", ccode,name);

    else

      fprintf(f,"\n:%s", contextBuf);

    }

  } while(iterHandle != NO_MORE_ITERATIONS);

fclose(f);



_FreeAll:

NWDSFreeBuf(outBuf);

NWDSFreeBuf(filter);

NWDSFreeContext(dContext);

}

