/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <advanced.h>



#define DELAY_TIME   200            /* delay time for clock update */

#define ONE_SECOND   1000

#define ONE_MINUTE   60*ONE_SECOND

#define FIFE_SECONDS 5*ONE_SECOND

#define MAX_H 80

#define MAX_V 24

#define PLANT 0x0b2a

#define NOPLANT 0x0b20

#define FENCE 0x0b23



typedef WORD FIELD [MAX_V][MAX_H];

FIELD f0,f1,*g0,*g1,*tmp;



extern int MaximumNumberOfPollingLoops,NumberOfPollingLoops;

int saving=0,run=0,saveCount=0;

long eventHandle=NULL;   // handle for RegisterForEvent

char *myname;



/* calculate sprite data using game of live algorithm */



int neighbours(int row,int col)

{

int h,v,n=0;

for (v=row-1;v<=row+1;v++)

  for (h=col-1;h<=col+1;h++)

    n+=(*g0)[v][h]==PLANT;

return n-((*g0)[row][col]==PLANT);

}



void calcNextGeneration(void)

{

int row,col;



for (row=1;row<MAX_V-1;row++)

  {

  ThreadSwitch();

  for (col=1;col<MAX_H-1;col++)

    {

    switch (neighbours(row,col)) {

      case 2: (*g1)[row][col]=(*g0)[row][col]; break;

      case 3: (*g1)[row][col]=PLANT; break;

      default: (*g1)[row][col]=NOPLANT; break;

      }

    }

  }

tmp=g0;

g0=g1;

g1=tmp;

}



void seedField(void)

{

int row,col;

g0=f0; g1=f1;



for (row=0;row<MAX_V;row++)

  {

  ThreadSwitch();

  for (col=0;col<MAX_H;col++)

    if (row==0 || row==(MAX_V-1) || col==0 || col==(MAX_H-1))

      (*g0)[row][col]=NOPLANT;

    else

      (*g0)[row][col]=(rand() % 4) ? NOPLANT : PLANT;

   }

}



void keyPressEventHandler(LONG p)

{

saving=saveCount=0;

}



void drawSprite(int x,int y,BYTE *p)

{

CopyToScreenMemory(MAX_V,MAX_H,p,x,y);

}



/* screen saving routine */



void doSave(void)

{

int n=0,i,myScreen,l,x,y;

WORD cols,rows;

char *p="PH Screen Saver";



myScreen=CreateScreen("PH Screen Saver Screen",AUTO_DESTROY_SCREEN | POP_UP_SCREEN);

if (myScreen==NULL)

  return;

SetCurrentScreen(myScreen);

HideInputCursor();

saving=1;

l=strlen(p);



if (GetSizeOfScreen(&rows,&cols))

  {

  rows=25;

  cols=80;

  }



seedField();

do {

   drawSprite(0,1,g0);

   calcNextGeneration();

   i=(MaximumNumberOfPollingLoops-NumberOfPollingLoops)*100/MaximumNumberOfPollingLoops;

   gotoxy(n/4,0);

   n++;

   if (n==200)

     {

     gotoxy(n/4,0);

     cprintf("%30s"," ");

     n=0;

     }

   else

     cprintf(" Server utilization: %3d %%",i);

   for (i=0;i<4;i++)

     if (saving)

       delay(DELAY_TIME);

   } while (saving);

if (myScreen)

  DropPopUpScreen(myScreen);

}



void cleanup()

{

if (eventHandle)

  UnregisterForEvent(eventHandle);

}





void usage()

   {

      ConsolePrintf ( "Usage %s [timeout in sec]\n", myname );

      ConsolePrintf ( " Default timeout = 60 s.\n");

      exit ( 0 );

   }





main ( int argc, char *argv [] )

{

   int   timeout=ONE_MINUTE,saveLimit;



   myname=argv[0];



   if ( argc>1 )

     {

     if (argv[1][0]=='?')

       usage();

     timeout=atoi(argv[1]);

     }



   saveLimit=(timeout*ONE_SECOND)/DELAY_TIME;



   eventHandle=RegisterForEvent(EVENT_KEY_WAS_PRESSED,keyPressEventHandler,NULL);

   if (eventHandle==NULL)

     return;

   AtUnload ( cleanup );

   run=1;

   do

   {

      delay(DELAY_TIME);

      saveCount++;

      if (saveCount>saveLimit)

        {

        doSave();

        saveCount=0;

        }

   } while ( run );

}

