/* standard file for programs using NetWare calls */



#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <nwbindry.h>

#include <niterror.h>

#include <nwmisc.h>

#include <nwenvrn.h>

#include <ctype.h>



#define NR_OF_PROPERTIES 10



enum pValType { ADDRESS, STRING, UNKNOWN };



typedef struct { char Name[16];

          int  Type; } propValDescription;



propValDescription p[NR_OF_PROPERTIES] =

   { "NET_ADDRESS", ADDRESS,

     "IDENTIFICATION", STRING,

     "HOMEDIRECTORY",STRING,

     "HOME_DIRECTORY",STRING,

     "Q_DIRECTORY",STRING,

     "NODE_CONTROL", UNKNOWN };



char    progName[16];



void usage(char *msg)

{

printf("%sUsage %s -{s|c[s]|d|r|w} [server/]OName OType PName [ PSecurity | PValue ]\n",msg,progName);

printf("  -s = scan, -c = create, -d = delete, -r = read, -w = write property\n");

printf("  -cs = create set property, default is create item property\n");

printf("  OName = name of object to be processed\n");

printf("  OType = hexadecimal type of object to be processed\n");

printf("  PName = name of property to be processed\n");

printf("  PSecurity = hexadecimal property security, needed only for create\n");

printf("  PValue = string to be assigned the property, needed only for write\n");

printf("  if option -s is selected wildcards are allowed for OName, OType or PName.\n");

printf("    Notice: wildcard for OType is FFFF or -1.\n");

exit(0);

}



void getprogname(char *argv0)

{

char *p1;

if ((p1=strrchr(argv0,'.'))!=NULL)

  *p1=0;

if ((p1=strrchr(argv0,'\\'))!=NULL)

  strncpy(progName,p1+1,sizeof(progName));

else

  strncpy(progName,argv0,sizeof(progName));

}



#define WRONG_ARGC "Wrong number of arguments\n"

#define WRONG_OPT "Wrong option\n"



propValDescription *getpropValDescription(char *propertyName)

{

propValDescription *p1;

int i;



for (i=0,p1=p;i<NR_OF_PROPERTIES;i++,p1++)

  if (!stricmp(p1->Name,propertyName))

    return(p1);

return(NULL);

}



char *getTDES(WORD objectType)

{

static char TDES[48];

switch (objectType) {

  case  0x112 : strcpy(TDES,"HP_33480A"); break;

  case  OT_WILD: strcpy(TDES,"WILD"); break;

  case  OT_UNKNOWN: strcpy(TDES,"UNKNOWN"); break;

  case  OT_USER: strcpy(TDES,"USER"); break;

  case  OT_USER_GROUP: strcpy(TDES,"USER_GROUP"); break;

  case  OT_PRINT_QUEUE: strcpy(TDES,"PRINT_QUEUE"); break;

  case  OT_FILE_SERVER: strcpy(TDES,"FILE_SERVER"); break;

  case  OT_JOB_SERVER: strcpy(TDES,"JOB_SERVER"); break;

  case  OT_GATEWAY: strcpy(TDES,"GATEWAY"); break;

  case  OT_PRINT_SERVER: strcpy(TDES,"PRINT_SERVER"); break;

  case  OT_ARCHIVE_QUEUE: strcpy(TDES,"ARCHIVE_QUEUE"); break;

  case  OT_ARCHIVE_SERVER: strcpy(TDES,"ARCHIVE_SERVER"); break;

  case  OT_JOB_QUEUE: strcpy(TDES,"JOB_QUEUE"); break;

  case  OT_ADMINISTRATION: strcpy(TDES,"ADMINISTRATION"); break;

  case  OT_NAS_SNA_GATEWAY: strcpy(TDES,"NAS_SNA_GATEWAY"); break;

  case  OT_REMOTE_BRIDGE_SERVER: strcpy(TDES,"REMOTE_BRIDGE_SERVER"); break;

  case  OT_TIME_SYNCHRONIZATION_SERVER: strcpy(TDES,"TIME_SYNCHRONIZATION_SERVER"); break;

  case  OT_ARCHIVE_SERVER_DYNAMIC_SAP: strcpy(TDES,"ARCHIVE_SERVER_DYNAMIC_SAP"); break;

  case  OT_ADVERTISING_PRINT_SERVER: strcpy(TDES,"ADVERTISING_PRINT_SERVER"); break;

  case  OT_BTRIEVE_VAP: strcpy(TDES,"BTRIEVE_VAP"); break;

  case  OT_PRINT_QUEUE_USER: strcpy(TDES,"PRINT_QUEUE_USER"); break;

  default : sprintf(TDES,"Unknown object type %04X",objectType);

  }



return(TDES);

}



void printPropertyValue(char *objectName,WORD objectType,char *propertyName)

{

BYTE    segment[128],pF,mS;

int     cC=0,i=NR_OF_PROPERTIES,pVT=UNKNOWN,segmentNumber=1;

long    *l,oID;

char    oName[48];

WORD    oType;

propValDescription *pVD;



do {

  if (ReadPropertyValue(objectName,objectType,propertyName,segmentNumber,

      segment,&mS,&pF))

    break;

  if (!(pF & BF_SET))

    /* no set */

    {

    if (pVD=getpropValDescription(propertyName))

      pVT=pVD->Type;

    switch (pVT) {

      case ADDRESS :

        printf("   %08lX:%08lX%04X (%04X)\n",LongSwap(* (long *)segment),

          LongSwap(* (long *)(segment+4)),IntSwap(* (int *)(segment+8)),

          IntSwap(* (int *)(segment+10))); break;

      case STRING :

        printf("   \"%s\"\n",(char *)segment); break;

      default : for (i=0;i<128;i++)

                 {

                 if (!(i % 32))

                   printf("   %02X",segment[i]);

                 else

                   printf("%02X",segment[i]);

                 if ((i %32)==31)

                   printf("\n");

                 }

      }

    }

  else

    /* set Type */

    for (i=0,l=(long *)segment;(i<32)&&(*l!=NULL);i++,l++)

      {

      oID=LongSwap(*l);

      if(!GetBinderyObjectName(oID,oName,&oType))

        printf("   %-32s (%s, ID: %08lX)\n",oName,getTDES(oType),oID);

      }

  if (mS)

    segmentNumber++;

  } while (mS);

}



int ScanBindery(char *oName,WORD oType,char *pName)

{

long objectID=-1l,sequenceNumber;

char objectName[48],propertyName[16],pHV,pS,pF,mP,oHP,oF,oS;

WORD objectType;

int sCC,first;



do {

  if (sCC=ScanBinderyObject(oName,oType,&objectID,objectName,&objectType,

          &oHP,&oF,&oS))

    break;

  sequenceNumber=-1l;

  first=1;

  do {

    if (ScanProperty(objectName,objectType,pName,&sequenceNumber,propertyName,

        &pF,&pS,&pHV,&mP))

      break;

    if (first)

      {

      printf("(%s) %s, ID: %08lX\n",getTDES(objectType),objectName,objectID);

      first=0;

      }

    printf("  Property %s\n",propertyName);

    if (pHV)

      printPropertyValue(objectName,objectType,propertyName);

    } while (mP);

  } while (!sCC);



if (sCC != NO_SUCH_OBJECT)

  return(sCC);

else

  return(0);

}



void makePropertyValue(BYTE *seg,char *pName)

{

static BYTE addr[16],*p;

char tmp[3];

int i;

if (stricmp(pName,"NET_ADDRESS"))

  return;

for (seg[24]=0,tmp[2]=0,i=0,p=addr;i<strlen(seg)/2;p++,i++)

  {

  strncpy(tmp,seg+i*2,2);

  *p=(BYTE) strtoul(tmp,NULL,16);

  }

memcpy(seg,addr,16);

}



void main(int argc, char *argv[])

{

char *oName,*pName,myName[48],server[48];

BYTE IS_SET=0,mS,pF,pSecurity,segment[128];

WORD oType;

int  cC;

long myID;



getprogname(argv[0]);



if (argv[1][0]!='-')

  usage("Missing option!\n");



if (argc<5)

  usage(WRONG_ARGC);



oName=strupr(argv[2]);



GetFileServerName(0,server);



GetBinderyAccessLevel(&mS,&myID);

GetBinderyObjectName(myID,myName,&oType);

printf("User %s on file server %s\n",myName,server);

oType=(WORD)strtol(argv[3],NULL,16);

pName=strupr(argv[4]);



switch (toupper(argv[1][1])) {

  case 'C' : if (argc < 6)

    usage(WRONG_ARGC);

  else

    {

    if (toupper(argv[1][2])=='S')

      IS_SET=BF_SET;

    pSecurity=(BYTE)strtol(argv[5],NULL,16);

    printf("Create: %s %X %s %X",oName,oType,pName,pSecurity);

    cC=CreateProperty(oName,oType,pName,BF_STATIC | IS_SET,pSecurity);

    }

  break;



  case 'D' : if (argc < 5)

    usage(WRONG_ARGC);

  else

    {

    printf("Delete: %s %X %s",oName,oType,pName);

    cC=DeleteProperty(oName,oType,pName);

    }

  break;



  case 'R' : if (argc < 5)

    usage(WRONG_ARGC);

  else

    {

    printf("Read: %s %X %s",oName,oType,pName);

    cC=ReadPropertyValue(oName,oType,pName,1,segment,&mS,&pF);

    if (!cC)

      printf("\n%s\n",(char *)segment);

       printPropertyValue(oName,oType,pName);

    }

  break;



  case 'S' : if (argc < 5)

    usage(WRONG_ARGC);

  else

    {

    printf("Scan: %s %04X %s\n",oName,oType,pName);

    cC=ScanBindery(oName,oType,pName);

    }

  break;



  case 'W' : if (argc < 6)

    usage(WRONG_ARGC);

  else

    {

    printf("Write: %s %X %s %s\n",oName,oType,pName,argv[5]);

    memset(segment,0,sizeof(segment));

    strncpy((char *)segment,argv[5],sizeof(segment));

    makePropertyValue(segment,pName);

    cC=WritePropertyValue(oName,oType,pName,1,segment,0);

    if (!cC)

//      printf("\n%s\n",(char *)segment);

      printPropertyValue(oName,oType,pName);

    }

  break;



  default :

    usage(WRONG_OPT);

  }

if (cC)

  printf(", CC=%02X\n",cC);

}



