//Qtest.c for Qtest.nlm



#include <stdio.h>

#include <string.h>

#include <process.h>

#include <conio.h>

//#include <ctype.h>

#include <nwqueue.h>

#include <nwcntask.h>

#include <nwconn.h>

#include <nwenvrn.h>

#include <nwmisc.h>



#include <nwdsapi.h>

#include <nwdsdc.h>

#include <nwdsasa.h>

#include <nwdsdsa.h>

#include <nwdsbuft.h>

#include <nwdsdefs.h>

#include <nwdsmisc.h>



#define Byte unsigned char



/* read password from console */



char *readpass(void)

{

static char pass[48]="\0";

int i=0;



while (i<48)

  {

  switch (pass[i]=getch()) {

    case 3: return(NULL);

    case 8: if (!i)

              putchar(7);

            else

              {

              printf("\b \b");

              i--;

              }

            break;

    case 13 : pass[i]=0; i=48; break;

    default : if (isgraph(pass[i]))

                {

                i++;

                putchar('_');

                }

              break;

    }

  }

printf("\n");

return(strupr(pass));

}



int retval,jhandle,connection,serverConn,loop,etype,balance,limit,unlimitedCredit;

char password[32],username[MAX_DN_CHARS],*attrib;

WORD connid;

NWQJobRec_t job;

LONG queueid;

uint32 cx;

NWDSContextHandle context;

NWDS_PRIVILEGES priv;



void main(int argc, char**argv)

{

        if (argc<3)

        {       printf("Syntax is LOAD QTEST PrintServerName QueueName\n");

                return;

        }



        context=NWDSCreateContext();

        NWDSGetContext(context,DCK_FLAGS,&cx);

        // cx |= DCV_TYPELESS_NAMES;

        NWDSSetContext(context,DCK_FLAGS,&cx);



        serverConn=SetCurrentConnection(-1);

        connection=GetCurrentConnection();



        //Enter the correct password here

        printf("Enter password for %s: ",argv[1]);

        strcpy(password,readpass());

        if (retval=NWDSLogin(context,NULL,argv[1],password,0))

        {  printf("Unable to login to Directory Services: Error %d.\r\n",retval);

                ReturnConnection(connection);

                NWDSFreeContext(context);

                return;

        }



        NWDSAuthenticate(connection,0,NULL);

        //NWDSWhoAmI(context,pservername);

        //NWDSMapNameToID(context,connection,pservername,&serverid);



        //get queue id

        if (retval=NWDSMapNameToID(context,connection,argv[2],&queueid))

        {  printf("Unable to get queue %s object id: Error %d.\r\n",argv[2],retval);

                goto DoneWithIt;

        }

        queueid=LongSwap(queueid);



        SetCurrentConnection(connection);



        //attach to queue

        if (retval=NWQAttachServer(queueid))

        {  printf("Error attaching to queue %s: Error %X.\r\n",argv[2],retval);

                goto DoneWithIt;

        }



        //service jobs

        printf("Press any key to stop servicing jobs...\n\n");

        while(!kbhit())

        {       ThreadSwitchWithDelay();

                if (!NWQBeginJobService(queueid,0xFFFF,&job,&jhandle))

                {       NWDSMapIDToName(context,connection,LongSwap(job.client.id),username);

                        printf("Servicing Job %08X - %s : %s\n",job.job.num,username,job.textJobDescription);



                        for (etype=0, loop=0; loop<3; loop++)

                        {       priv=0;

                                switch(loop)

                                {       case 0: attrib=A_ACCOUNT_BALANCE; break;

                                        case 1: attrib=A_ALLOW_UNLIMITED_CREDIT; break;

                                        case 2: attrib=A_MINIMUM_ACCOUNT_BALANCE; break;

                                }

                                NWDSGetEffectiveRights(context,argv[1],username,attrib,&priv);

                                if ( !(priv & DS_ATTR_SUPERVISOR) && !(priv & (DS_ATTR_READ | DS_ATTR_WRITE)) )

                                        etype |= (1<<loop);

                        }

                        if (etype)

                                printf("\tNo rights to %s %s %s\n",

                                                                 (etype & 1) ? "[Balance]" : "",

                                                                 (etype & 2) ? "[UnlimitedCredit]" : "",

                                                                 (etype & 4) ? "[Limit]" : "");



                        balance=unlimitedCredit=limit=0;

                        ReadAttribute(username,A_ACCOUNT_BALANCE,&balance);

                        ReadAttribute(username,A_ALLOW_UNLIMITED_CREDIT,&unlimitedCredit);

                        ReadAttribute(username,A_MINIMUM_ACCOUNT_BALANCE,&limit);

                        printf("\t%s=%d\n\t%s=%s\n\t%s=%d\n",

                                                A_ACCOUNT_BALANCE,balance,

                                                A_ALLOW_UNLIMITED_CREDIT, (unlimitedCredit) ? "Yes" : "No",

                                                A_MINIMUM_ACCOUNT_BALANCE,limit);



                        NWQEndJobService(queueid,job.job.num,0,jhandle);

                        printf("Done Servicing %08X\n\n",job.job.num);

                }

        }

        getch();



        //detach from queue

        NWQDetachServer(queueid);



        DoneWithIt:

        NWDSLogout(context);

        ReturnConnection(connection);

        NWDSFreeContext(context);

}



NWDSCCODE ReadAttribute(char *object, char *attrib, void *value)

{

        NWDS_BUFFER *inbuf,*outbuf;

        NWSYNTAX_ID syntax;

        NWDS_ITERATION iterHandle;

        NWCOUNT attrCount,valCount;

        char attrName[MAX_SCHEMA_NAME_CHARS+1];

        NWDSCCODE retval;



        retval=NWDSAllocBuf(DEFAULT_MESSAGE_LEN,&inbuf);

        retval=NWDSAllocBuf(DEFAULT_MESSAGE_LEN,&outbuf);

        retval=NWDSInitBuf(context,DSV_READ,inbuf);

        retval=NWDSPutAttrName(context,inbuf,attrib);



        iterHandle=NO_MORE_ITERATIONS;

        retval=NWDSRead(context,object,DS_ATTRIBUTE_VALUES,FALSE,inbuf,&iterHandle,outbuf);

        if (retval==0)

        {       retval=NWDSGetAttrCount(context,outbuf,&attrCount);

                retval=NWDSGetAttrName(context,outbuf,attrName,&valCount,&syntax);

                retval=NWDSGetAttrVal(context,outbuf,syntax,value);

        }



        if (retval)

        {       switch(syntax)

                {       case SYN_BOOLEAN:

                                *(Byte *)value=0;

                                break;

                        case SYN_COUNTER:

                        case SYN_INTEGER:

                                *(long *)value=0;

                                break;

                }

        }

        NWDSFreeBuf(outbuf);

        NWDSFreeBuf(inbuf);

        return(retval);

}





