/* rdated with fast screen output via CopyToScreenMemory

   V 1.40 requires Netware 4.x because only 4.x handles time zones and

   daylight saving correctly */



#include <arpa\inet.h>

#include <conio.h>

#include <ctype.h>

#include <errno.h>

#include <io.h>

#include <netinet\in.h>

#include <nwenvrn.h>

#include <niterror.h>

#include <nwmisc.h>

#include <nwtypes.h>

#include <process.h>

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <sys\socket.h>

#include <sys\types.h>

#include <time.h>



//#define DEBUG

#define  STD_TIME  (LONG) 86400l*(365l*70l + 17l)



#define PC31_DATA 0x300        /* data port */

#define PC31_STAT PC31_DATA+1  /* status port */

#define GETDATA 0              /* read command for clock data */

#define TIMEOUT 100            /* 100 ms timeout for status to stay busy */

#define QUARTZ 1

#define DELAY_TIME 200         /* delay time for clock update */

#define DCF77SYNC 1            /* clock synchronous with DCF77 */

#define IS_MESZ   2            /* Day light saving on */

#define TIME_INVALID 128       /* time unvalid after reset */

#define MAXDELTA 5             /* maximum delta time between DCF77 and internal

                                  clock */

#define ONE_DAY 86400l



struct {

       BYTE Sec100;

       BYTE Second;

       BYTE Minute;

       BYTE Hour;

       BYTE DayOfMonth;

       BYTE DayOfWeek;

       BYTE Month;

       BYTE Year;

       BYTE Status;

       } clockdata;



#define UDP_POS        5,20

#define TCP_POS        5,22

#define UDP_COUNT_POS  70,20

#define TCP_COUNT_POS  70,22

#define CLOCK_POS      7,5

#define DATE_POS       5,15



int readPC31(void);

time_t isMEST(time_t *t);

time_t getmytime(void);



void mySetFileServerDateAndTime(int year,int month,int mday,int hour,int min,int sec)

{

BYTE fsdt[7];

GetFileServerDateAndTime(fsdt);



ConsolePrintf("tz(%s %s):%d dst:%d, %02d.%02d.%02d %02d.%02d.%04d Server Time:"

"%02d.%02d.%02d %02d.%02d.%02d, %X\n",

tzname[0],tzname[1],timezone,daylight,hour,min,sec,mday,month,year+1900,

fsdt[3],fsdt[4],fsdt[5],fsdt[2],fsdt[1],fsdt[0]+1980,clockdata.Status);

}



/* 8x8 bitmap of chars '.'..':' */



char char8x8[104] = {

0x00,0x00,0x00,0x00,0x00,0x38,0x38,0x00,0x06,0x0c,0x18,0x30,0x60,0xc0,0x80,0x00,

0x7c,0xc6,0xce,0xde,0xf6,0xe6,0x7c,0x00,0x18,0x78,0x18,0x18,0x18,0x18,0x7e,0x00,

0x7c,0xc6,0x0c,0x18,0x30,0x66,0xfe,0x00,0x7c,0xc6,0x06,0x3c,0x06,0xc6,0x7c,0x00,

0x0c,0x1c,0x3c,0x6c,0xfe,0x0c,0x0c,0x00,0xfe,0xc0,0xfc,0x06,0x06,0xc6,0x7c,0x00,

0x7c,0xc6,0xc0,0xfc,0xc6,0xc6,0x7c,0x00,0xfe,0xc6,0x06,0x0c,0x18,0x18,0x18,0x00,

0x7c,0xc6,0xc6,0x7c,0xc6,0xc6,0x7c,0x00,0x7c,0xc6,0xc6,0x7e,0x06,0xc6,0x7c,0x00,

0x00,0x1c,0x1c,0x00,0x00,0x1c,0x1c,0x00

};



#define NCHARS 13



char boxdata[NCHARS*128];  /* NCHARS * 16 bytes/row * 8 rows */



struct sockaddr_in t_server_sockaddr, u_server_sockaddr;

struct sockaddr_in t_client_sockaddr, u_client_sockaddr;

int s_tcp, s_udp, useDCF77=1, screen_in_use=0;

LONG u_count=0, t_count=0, syncs=0;

#ifdef DEBUG

char dstflag='0';

#endif



/* initialize boxdata */



void fillboxdata(void)

{

int i,j,k;

for (i=0;i<NCHARS*8;i++)

  for (j=0,k=0x80;j<16;j+=2,k>>=1)

    {

    boxdata[(i<<4)+j]=((char8x8[i]&k) ? '' :' ');  /* char */

    boxdata[(i<<4)+j+1]=0x0e;                      /* attr LIGHT YELLOW */

    }

}



/* return 3600 if daylight saving is active in MET */



time_t isMEST(time_t *t)

{

int days[12]={0,31,59,90,120,151,181,212,243,273,304,334};

struct tm *tnow;

time_t T;

int add1=0,d0,d1,d2,h0,h1,h2;

if (t)

  tnow=localtime(t);

else

  {

  time(&T);

  tnow=localtime(&T);

  }



add1=((tnow->tm_year) % 4)==0;

d0=(((tnow->tm_year)*5)/4)%7;



d1=days[3]+add1-((days[3]+d0)%7)-1;

d2=days[10]+add1-((days[10]+d0)%7)-1;



h1=d1*24+2; h2=d2*24+2;

h0=tnow->tm_yday*24+tnow->tm_hour;

if (h0>=h1 && h0<h2)

  return 3600;

else

  return 0;

}



/* calculate time difference between Server time and DCF77 clock */



int delta(BYTE *fst)

{

struct tm lt;



lt.tm_year=fst[0];

lt.tm_mon=fst[1]-1;

lt.tm_mday=fst[2];

lt.tm_hour=fst[3];

lt.tm_min=fst[4];

lt.tm_sec=fst[5];

lt.tm_isdst=daylight;

return abs(mktime(&lt)-getmytime());

}



/* get time from internal or DCF77 clock */



time_t getmytime(void)

{

struct tm t;

if (readPC31() || (!useDCF77))

  return(time(NULL));



t.tm_sec=clockdata.Second;

t.tm_min=clockdata.Minute;

t.tm_hour=clockdata.Hour;

t.tm_mday=clockdata.DayOfMonth;

t.tm_mon=clockdata.Month-1;

t.tm_year=clockdata.Year;

t.tm_isdst=daylight;

return(mktime(&t));

}



/* wait until screen is free and request screen */



#define requestScreen do delay(1); while (screen_in_use); screen_in_use=1



/* release screen */



#define releaseScreen screen_in_use=0



/* display string s in 8x8 big letters */



void bigprint(int x,int y,char *s)

{

int j;

char b;

requestScreen;

for (j=0; (j<8)&&s[j]; j++)

  {

    b=s[j];

    if (b<'.'||b>':')

      break;

    CopyToScreenMemory(8,8,&boxdata[(b-'.')*128],x+8*j,y);

   }

releaseScreen;

}



/*

 * Note that daughter is careful to delete the socket before exiting, because

 * NW/386 does not clean up until the entire NLM unloads.

 */

void tcp_daughter(void *parm)

{

int                s = (int) parm;

int                rc;

LONG               MyTime;

struct sockaddr_in temp;

NETINET_DEFINE_CONTEXT



while (rc = read(s, &MyTime, sizeof (MyTime)))

  {

    if (rc == -1)

      {

         perror("tcp_read");

         close(s);

         ExitThread(TSR_THREAD, 1);

      }



    MyTime=getmytime();

    MyTime=LongSwap(MyTime+STD_TIME);



    rc = write(s, &MyTime, sizeof(MyTime));

    if (rc == -1)

      {

        perror("tcp_write");

        close(s);

        ExitThread(TSR_THREAD, 1);

      }



    rc=sizeof(temp);

    getpeername(s, (struct sockaddr *) &temp, &rc);



    ++t_count;

    requestScreen;

    gotoxy(TCP_POS);

    printf("TCP: %-20s",inet_ntoa(temp.sin_addr));

    gotoxy(TCP_COUNT_POS);

    printf("%8lu",t_count);

    releaseScreen;

  }

shutdown(s,2);

close(s);

ExitThread(TSR_THREAD, 0);

}



void tcp_loop()

{

int                ds, rc, arg;



for (;;)

  {

    arg = sizeof (t_client_sockaddr);

    ds = accept(s_tcp, (struct sockaddr *) & t_client_sockaddr, &arg);

    if (ds == -1)

      {

        perror("tcp_accept");

        rc=close(s_tcp);

        rc=close(s_udp);

        exit(1);

      }



    rc = BeginThread(tcp_daughter, (void *) NULL, 8192, (void *) ds);

  }

}



void udp_loop()

{

int                rc, arg;

LONG               MyTime;

NETINET_DEFINE_CONTEXT



for (;;)

  {

    arg = sizeof (u_client_sockaddr);

    rc = recvfrom(s_udp, (char *) &MyTime, sizeof(MyTime), 0, (struct sockaddr *) & u_client_sockaddr, &arg);

    if (rc == -123)

      {

        perror("udp_recvfrom");

        rc=close(s_tcp);

        rc=close(s_udp);

        exit(1);

      }



    MyTime=getmytime();

    MyTime=LongSwap(MyTime+STD_TIME);



    rc = sendto(s_udp, (char *) &MyTime, sizeof(MyTime), 0, (struct sockaddr *) & u_client_sockaddr, sizeof (u_client_sockaddr));

    if (rc == -1)

      {

        perror("udp_sendto");

        rc=close(s_tcp);

        rc=close(s_udp);

        exit(1);

      }



    ++u_count;

    requestScreen;

    gotoxy(UDP_POS);

    printf("UDP: %-20s",inet_ntoa(u_client_sockaddr.sin_addr));

    gotoxy(UDP_COUNT_POS);

    printf("%8lu",u_count);

    releaseScreen;

  }

}



/* Read data packet from clock. First the command byte is written to the status

   port and status is read until busy flag is clear or timeout reached. If busy

   is clear the structure clockdata is filled with data bytes read from the data

   port. This function returns 0 on success or -1 if timeout occured

   V 1.1: If useDCF77 is false then data of internal clock is used */



int readPC31(void)

{

int i;

BYTE *p;

time_t t,dst;

struct tm *tlocal;



dst=daylight * 3600; //isMEST(NULL);



if (!useDCF77) /* use internal clock */

  {

  time(&t); /* get seconds since 1970 */

  // t+=dst;

  tlocal=localtime(&t);

  clockdata.Second=tlocal->tm_sec;

  clockdata.Minute=tlocal->tm_min;

  clockdata.Hour=tlocal->tm_hour;

  clockdata.DayOfMonth=tlocal->tm_mday;

  clockdata.Month=tlocal->tm_mon+1;

  clockdata.Year=tlocal->tm_year;

  clockdata.Status=dst ? IS_MESZ : 0;

  return(0);

  }



outp(PC31_STAT,GETDATA);

for (i=0;i<TIMEOUT;i++)

  if (inp(PC31_STAT) & 1) /* busy */

    delay(1);

  else

    break;

if (i==TIMEOUT)

  return(-1);



for (i=0,p=(BYTE *)&clockdata;i<sizeof(clockdata);i++,p++)

  *p=inp(PC31_DATA);

return(0);

}



main(int argc, char *argv[])

{

int i,rc, run=1,maxdeltaTime=ONE_DAY,deltaTime=MAXDELTA;

char timeString[16];

BYTE fsdt[7];



   for (i=1;i<argc;i++)

     {

     if (!stricmp(argv[i],"-h"))

       {

        printf("USAGE %s [-i][-h][-d n][-md n]\n",argv[0]);

        printf("         -i Use internal clock (instead on DCF77 Hardware),\n");

        printf("         -h display this help,\n");

        printf("         -d set delta time to n s, default %d s\n",MAXDELTA);

        printf("         -md set max delta time to n s, default %d s\n",ONE_DAY);

        exit(42);

        }

     if (!strcmp(argv[i],"-d"))

       if (argc>i)

         {

         deltaTime=abs(atoi(argv[++i]));

         if (deltaTime==0)

           deltaTime=MAXDELTA;

         }

     if (!strcmp(argv[i],"-md"))

       if (argc>i)

         {

         maxdeltaTime=abs(atol(argv[++i]));

         if (maxdeltaTime==0)

           maxdeltaTime=ONE_DAY;

         }

     }



if (CheckNetWareVersion(4,0,0,1,1)== VERSION_NUMBER_TOO_LOW)

  {

  printf("This NLM requires Netware version 4.x\n");

  exit(42);

  }

fillboxdata();



if (argc>1)

  if (!stricmp(argv[1],"-i"))

    useDCF77=0;



if (useDCF77 && readPC31())

  {

  printf("Error reading clockdata\n");

  return;

  }



s_tcp = socket(PF_INET, SOCK_STREAM, 0);

if (s_tcp == -1)

  {

    perror("tcp_socket");

    exit(1);

  }



 s_udp = socket(PF_INET, SOCK_DGRAM, 0);

 if (s_udp == -1)

   {

     perror("udp_socket");

     exit(1);

   }



t_server_sockaddr.sin_family = AF_INET;

t_server_sockaddr.sin_port = htons(37);

rc = bind(s_tcp, (struct sockaddr *) & t_server_sockaddr,sizeof (t_server_sockaddr));

if (rc == -1)

  {

    perror("tcp_bind");

    rc=close(s_tcp);

    rc=close(s_udp);

    exit(1);

  }



u_server_sockaddr.sin_family = AF_INET;

u_server_sockaddr.sin_port = htons(37);

rc = bind(s_udp, (struct sockaddr *) & u_server_sockaddr,sizeof (u_server_sockaddr));

if (rc == -1)

  {

    perror("udp_bind");

    rc=close(s_tcp);

    rc=close(s_udp);

    exit(1);

  }



rc = listen(s_tcp, 5);

if (rc == -1)

  {

    perror("tcp_listen");

    rc=close(s_tcp);

    rc=close(s_udp);

    exit(1);

  }



SetAutoScreenDestructionMode(TRUE);

printf("RDATED (UDP/TCP), v. 1.40, (c) 1992- 1996 by Peter Heitzer and Edmund Weber\n");

printf("Clock is %s, Sync for %d s < delta < %d s\n\n",

       useDCF77 ? "DCF77 clock" : "internal clock",deltaTime,maxdeltaTime);



HideInputCursor();



rc = BeginThread(tcp_loop, (void *) NULL, 8192, NULL);

rc = BeginThread(udp_loop, (void *) NULL, 8192, NULL);



/* Read clock every 1/4 sec and set server time every minute. Also the current

   time from the DCF77 clock is displayed as <status>: <hour>:<min>.sec where

   <status> is 'D' if clock is synchronized with DCF77 or 'Q' if clock runs

   free on its own quartz oscillator */



do

  {

    tzset();

    if (!readPC31())

      {

       GetFileServerDateAndTime(fsdt);

       if (!clockdata.Second) /* full minute */

         {

           if (readPC31())

             continue;

           i=delta(fsdt);

           if (i > deltaTime && i<maxdeltaTime )

             {

             SetFileServerDateAndTime(

             clockdata.Year,

             clockdata.Month,

             clockdata.DayOfMonth,

             clockdata.Hour,

             clockdata.Minute,

             clockdata.Second );

             syncs++;

             }

         }

           sprintf(timeString,"%02d:%02d:%02d",clockdata.Hour,clockdata.Minute,clockdata.Second);

           bigprint(CLOCK_POS,timeString);

           requestScreen;

           gotoxy(DATE_POS);

           printf("%s %02d.%02d.%02d, Server time: %02d:%02d:%02d %02d.%02d.%04d  %8ld syncs",

           (clockdata.Status & IS_MESZ) ? "MEST" : "MET ",

                  clockdata.DayOfMonth,clockdata.Month,clockdata.Year,

                  fsdt[3],fsdt[4],fsdt[5],fsdt[2],fsdt[1],fsdt[0]+1900,syncs);

#ifdef DEBUG

           if (kbhit())

             dstflag=getch();

#endif

           releaseScreen;

      }

    delay(DELAY_TIME);

  }

while (run);

}

