#include <stdio.h>

#include <stdlib.h>

#include <nwtypes.h>

#include <conio.h>

#include <time.h>

#include <process.h>

#include <nwenvrn.h>

#include <nwservst.h>

#include <advanced.h>

#include <globals.h>



#define MAX_H 80

#define MAX_V 24

#define PLANT 0x0b2a

#define NOPLANT 0x0b20

#define FENCE 0x0b23

#define MAXBALLS 50

#define MAX_X    80

#define MAX_Y    25

#define MAXSTARS 50



#ifndef random

  #define random(x) ((x) ? rand()%(x) : 0 )

#endif





typedef WORD FIELD [MAX_V][MAX_H];



typedef struct pcb {

                   struct pcb *next;

                   char f1[26];

                   char pName[16];

                   } PCB;



FIELD f0,f1,*g0,*g1,*tmp;

WORD ball=PLANT,noball=NOPLANT;



struct startype

  {

    int in;

    int x;

    int y;

    int sx;

    int sy;

  };



extern int saving;

extern int ActivePCBsList;

// extern int RunningProcess;

// extern int MaximumNumberOfPollingLoops,NumberOfPollingLoops;

int TotalKnownSystemMemory(void);

int symbolImported=0;

LONG (* SSGetFSInfo) (BYTE *buffer,LONG bufferLen);



struct balltype

  {

    int x;

    int y;

    int sx;

    int sy;

  };



int ServerUtilization(void)

{

GetFileServerInfoStructure FSInfo;



if (!symbolImported)

  {

  SSGetFSInfo=ImportSymbol(GetNLMHandle(),"SSGetFileServerInfo");

  symbolImported=1;

  }



//int i=MaximumNumberOfPollingLoops,j=NumberOfPollingLoops;

//return i ? ((i-j)*100)/i : 100;

if (SSGetFSInfo)

  {

  SSGetFSInfo(&FSInfo,sizeof(FSInfo));

  return (int) FSInfo.serverUtilization;

  }

return rand() % 100;

}



void ball_save(LONG balls, LONG speed, LONG DELAY)

{

int i,j;

static struct balltype b[MAXBALLS];



if ((balls>MAXBALLS)||(balls<1)) return;



for (i=0; i<balls; i++)

  {

    b[i].x=random(MAX_X);      /* Zufllige Position */

    b[i].y=random(MAX_Y);

    do

      {

       b[i].sx=random(speed*2+1)-speed;    /* Zufllige Geschwindigkeit */

       b[i].sy=random(speed*2+1)-speed;

      }

    while ((b[i].sy==0)&&(b[i].sx==0)); /* Speed nicht 0 */

  }



while (saving)

  {

    for (i=0; i<balls; i++)

      {

        CopyToScreenMemory(1,1,(BYTE*)&noball,b[i].x,b[i].y); /* Alten Ball lschen */



        b[i].x=b[i].x+b[i].sx;                     /* Neue Position berechnen */

        b[i].y=b[i].y+b[i].sy;



        if (b[i].x<0)                              /* linke Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=0;

          }

        if (b[i].x>=MAX_X)                         /* rechte Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=MAX_X-1;

          }

        if (b[i].y<0)                              /* untere Wand ? */

          {

            b[i].sy=-b[i].sy;

            b[i].y=0;

          }

        if (b[i].y>=MAX_Y)                         /* obere Wand ? */

          {

            b[i].sy=-b[i].sy;

            b[i].y=MAX_Y-1;

          }

        for (j=0; j<i; j++)                        /* anderer Ball ? */

          if ((b[i].x==b[j].x)&&(b[i].y==b[j].y))

            do

              {

                b[i].sx=random(speed*2+1)-speed;

                b[i].sy=random(speed*2+1)-speed;

              }

            while ((b[i].sy==0)&&(b[i].sx==0));



        CopyToScreenMemory(1,1,(BYTE*)&ball,b[i].x,b[i].y);

      }

    delay (DELAY);

  }

}



/* calculate sprite data using game of live algorithm */



int neighbours(int row,int col)

{

int h,v,n=0;

for (v=row-1;v<=row+1;v++)

  for (h=col-1;h<=col+1;h++)

    n+=(*g0)[v][h]==PLANT;

return n-((*g0)[row][col]==PLANT);

}



void calcNextGeneration(void)

{

int row,col;



for (row=1;row<MAX_V-1;row++)

  {

  ThreadSwitch();

  for (col=1;col<MAX_H-1;col++)

    {

    switch (neighbours(row,col)) {

      case 2: (*g1)[row][col]=(*g0)[row][col]; break;

      case 3: (*g1)[row][col]=PLANT; break;

      default: (*g1)[row][col]=NOPLANT; break;

      }

    }

  }

tmp=g0;

g0=g1;

g1=tmp;

}



void seedField(void)

{

int row,col;

g0=f0; g1=f1;



for (row=0;row<MAX_V;row++)

  {

  ThreadSwitch();

  for (col=0;col<MAX_H;col++)

    if (row==0 || row==(MAX_V-1) || col==0 || col==(MAX_H-1))

      (*g0)[row][col]=NOPLANT;

    else

      (*g0)[row][col]=(rand() % 4) ? NOPLANT : PLANT;

   }

}



void live_save(LONG p1,LONG p2, LONG waitTime)

{

seedField();

do {

   CopyToScreenMemory(MAX_V,MAX_H,(BYTE*)g0,0,1);

   calcNextGeneration();

   delay(waitTime);

   } while(saving);

}



void ping_pong_save(LONG speed, LONG DELAY, LONG p3)

{

int i,b_x,b_y,b_sx,b_sy,pos=34;



WORD noracket[10]={ NOPLANT,NOPLANT,NOPLANT,NOPLANT,NOPLANT,

                    NOPLANT,NOPLANT,NOPLANT,NOPLANT,NOPLANT},

     racket[10]={ 0xb00 | '-',0xb00 | '-',0xb00 | '-',0xb00 | '-',0xb00 | '-',

                  0xb00 | '-',0xb00 | '-',0xb00 | '-',0xb00 | '-',0xb00 | '-'};



b_x=random(MAX_X);      /* Zufllige Position */

b_y=0;

b_sx=random(speed*2+1)-speed;

do b_sy=random(speed*2+1)-speed; while (b_sy==0);





while (saving)

  {

    CopyToScreenMemory(1,1,(BYTE*)&noball,b_x,b_y);

    CopyToScreenMemory(1,10,(BYTE*)noracket,pos,24);





    b_x=b_x+b_sx;                     /* Neue Position berechnen */

    b_y=b_y+b_sy;



    if (b_x<pos+5)

      {

        pos=pos-1;

        if (pos<0) pos=0;

      }

    if (b_x>pos+5)

      {

        pos=pos+1;

        if (pos>=70) pos=69;

      }





    if (b_x<0)                              /* linke Wand ? */

      {

        b_sx=-b_sx;

        b_x=0;

      }

    if (b_x>=MAX_X)                         /* rechte Wand ? */

      {

        b_sx=-b_sx;

        b_x=MAX_X-1;

      }

    if (b_y<0)                              /* obere Wand ? */

      {

        b_sy=-b_sy;

        b_y=0;

      }

    if (b_y>=MAX_Y)                         /* untere Wand ? */

      {

        CopyToScreenMemory(1,10,(BYTE*)&racket,pos,24);

        if ((b_x>=pos)&&(b_x<=pos+10))

          {

            b_sy=-b_sy;

            b_sx=random(speed*2+1)-speed;

            b_y=MAX_Y-1;

          }

        else

         {

           b_x=random(MAX_X);      /* Zufllige Position */

           b_y=0;

           b_sx=random(speed*2+1)-speed;

           do b_sy=random(speed*2+1)-speed; while (b_sy==0);

           CopyToScreenMemory(1,1,(BYTE*)&ball,b_x,b_y);

         }

      }

    else

      {

        CopyToScreenMemory(1,1,(BYTE*)&ball,b_x,b_y);

        CopyToScreenMemory(1,10,(BYTE*)&racket,pos,24);

      }



    delay (DELAY);

  }

}



/* balls    : Zahl der Blle

   gravity  : Anziehungskraft (in 1/10)

   slower   : Dmpfung beim Aufprall am Boden in 1/10

   speed    : Maximale X-Speed

   delay    : ms Zeit zwischen 2 Berechnugen */



void jump_save(LONG balls, LONG speed, LONG DELAY)

{

int i,j,gravity=2,slower=10;

struct balltype b[MAXBALLS];



#define MAX_YY 250



if ((balls>MAXBALLS)||(balls<1)) return;



for (i=0; i<balls; i++)

  {

    b[i].x=random(MAX_X);      /* Zufllige Position */

    b[i].y=random(MAX_Y);

    b[i].sx=random(speed*2+1)-speed;

    b[i].sy=0;

  }





while (saving)

  {

    for (i=0; i<balls; i++)

      {



        CopyToScreenMemory(1,1,(BYTE*)&noball,b[i].x,b[i].y/10); /* Alten Ball lschen */



        b[i].x=b[i].x+b[i].sx;                     /* Neue Position berechnen */

        b[i].y=b[i].y+b[i].sy;

        b[i].sy=b[i].sy+gravity;



        if (b[i].x<0)                              /* linke Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=0;

          }

        if (b[i].x>=MAX_X)                         /* rechte Wand ? */

          {

            b[i].sx=-b[i].sx;

            b[i].x=MAX_X-1;

          }

        if (b[i].y<0)                              /* untere Wand ? */

          {

            b[i].sy=-b[i].sy;

            b[i].y=0;

          }

        if (b[i].y>=MAX_YY)                         /* obere Wand ? */

          {

            b[i].sy=-b[i].sy+slower;

            b[i].y=MAX_YY-1;

            if (b[i].sy>-slower)

              {

                b[i].x=random(MAX_X);      /* Zufllige Position */

                b[i].y=random(MAX_YY);

                b[i].sx=random(speed*2+1)-speed;

                b[i].sy=0;

              }

          }

        for (j=0; j<i; j++)                        /* anderer Ball ? */

          if ((b[i].x==b[j].x)&&(b[i].y==b[j].y))

            b[i].sx=random(speed*2+1)-speed;



        CopyToScreenMemory(1,1,(BYTE*)&ball,b[i].x,b[i].y/10);

      }

    delay (DELAY);

  }

}



void calc_abend(void)

{

time_t t;

int i,j,maxp=0,isNW4;

PCB *p;

char cN[80],rev[80],revD[80],cR[80];

char *processes[]={"Phaser discharge",

              "Server 03",

              "FAT update",

              "CPU cooling",

              "Tricorder adjustment",

              "Intercom",

              "Matter/antimatter propulsion",

              "Oil leakage detection",

              "Remirror",

              "MakeThread",

              "Console Command",

              "Windows 95 remover",

              "MIDI multi mode",

              "Crossfade loop finder",

              "Arpeggiator",

              "Low pass filter",

              "Envelope generator",

              "Polling"};



#define MAXP sizeof(processes)/sizeof(char *)



isNW4=(CheckNetWareVersion(4,0,0,1,1)==0);



t=time(NULL);



GetFileServerDescriptionStrings(cN,rev,revD,cR);

cprintf("\r\nSystem halted %s",ctime(&t));

cprintf("\r\nAbend: %s Processor Exception (Error code %08lx)","General",ServerUtilization());

cprintf("\r\n       OS version: %s %s",rev,revD);

cprintf("\r\n       Running Process: %s process",processes[rand()%MAXP]);

cprintf("\r\n       EIP: %lx ",rand()*256+rand());

cprintf("\r\n       Stack: ");

for (i=0;i<16;i++)

  cprintf("%02X ",(BYTE)rand());

for (j=0;j<2;j++)

  {

  cprintf("\r\n              ");

  for (i=0;i<16;i++)

    cprintf("%02X ",(BYTE)rand());

  }

if (!isNW4)

  cprintf("\r\nPress \"Y\" to copy diagnostic image to diskette.  Otherwise\r\nPower off and back on to restart.\r\n");

else

  cprintf("\r\nPress \"Y\" to copy diagnostic image to disk.\n\rOtherwise press \"X\" to exit.\r\n");

}



void abend_save(LONG p1,LONG p2, LONG p3)

{

int count=0;



while (saving)

  {

  if ((count % 100) == 0)

    {

    clrscr();

    gotoxy(0,rand() % 12);

    calc_abend();

    }

  count++;

  delay(100);

  }

}



void mydelay(int ticks)

{

int j;

if (!saving)

  return;

for (j=0; (j<ticks/100)&&(saving); j++)

 delay(100);

}





void boot_savel(long MEGS, long error)

{

long i=0;



clrscr();

mydelay(1000);



printf("BIOS V1.00 Copyright 1995, Webber Systems Corporation\n\n");



printf("000000 KILOBYTES EXTENDED MEMORY GOOD\r");

for (i=0; i<=MEGS; i++)

  {

    printf("%06lu\r",i*1024);

    if ((error==5)&&(i>=(MEGS/2)))

      {

        printf("%06lu MEMORY ERROR, SIMM #%0X IS DEAD        ",i*1024,random(2000));

        return;

      }

    mydelay(400);

  }



for (i=0; i<=MEGS; i++)

  {

    printf("%06lu\r",i*1024);

    mydelay(100);

  }

for (i=0; i<=MEGS; i++)

  {

    printf("%06lu\r",i*1024);

    mydelay(100);

  }



printf("\n000256 KILOBYTES SHADOW RAM\n\n");



mydelay(1000);

printf("1 Diskette Drives\n");

printf("1 Hard Disks\n");

printf("2 Parallel Ports\n");

printf("2 Serial Ports\n");

printf("Pointing Device installed\n\n\n");

mydelay (1000);

printf("68040 CPU ready\n");

printf("Internal Cache enabled\n");

printf("External Cache enabled\n");

printf("RAM BIOS enabled\n");

printf("VIDEO RAM BIOS enabled\n\n");

mydelay(500);

switch (error)

  {

    case 0 : printf("DISK READ ERROR, PRESS ANY KEY TO REBOOT"); break;

    case 1 : printf("KEYBOARD NOT PRESENT, PRESS F1 TO CONTINUE"); break;

    case 2 : printf("CONFIGURATION MISMATCH, PLEASE RUN SETUP"); break;

    case 3 : printf("Starten von MS-DOS .....\n\n");

             printf("HIMEM testet den erweiterten Speicher .....");

             mydelay(5000);

             printf(" beendet\n");

             printf("EMM386 Fehler #%04X System gestoppt.",random(2000));

             break;

    case 4 : printf("Loading LINUX 1.01 Patchlevel 911");

             for (i=0; i<20; i++) {printf("."); mydelay(100);}

             printf("\nPANIC: Trying to dump %i pages",MEGS*20);

             for (i=0; i<MEGS*20; i++) {printf("."); mydelay(100);}

             printf("\n Press CTRL-ALT-DEL to reboot");

   }

}



void boot_save(long MEGS, long start, long dummy)

{

long error;



error=start;

MEGS=TotalKnownSystemMemory()/(1024*1024);

do

  {

    boot_savel(MEGS, error);

    mydelay(5000);

    error++;

    if (error==6) error=0;

  }

while (saving);

}



void BSOD_save(SCREEN_SAVER *self, long l2, long l3)

{

int x=0,y=0,i=0,n;

n=80-strlen(self->description);

while (saving) {

  i++;

  if (i==100)

    {

    gotoxy(x=random(n),y=random(25));

    cprintf(self->description);

    delay(1000);

    gotoxy(x,y);

    cprintf("%40s"," ");

    i=0;

    }

  delay(100);

  }

}



int putstar(int X, int Y, char c)

{

int x,y;

WORD st=0x0b00|c;

x=X/400+12;

y=Y/120+38;



if ((x<25)&&(x>=0)&&(y<79)&&(y>=0))

  {

    CopyToScreenMemory (1,1,&st,y,x);

    return(0);

  }

else return(1);

}



void star_save(int stars, int DELAY, LONG p3)

{

int i,j;

struct startype s[MAXSTARS];





if ((stars>MAXSTARS)||(stars<1)) return;

clrscr();



do

  {

    for (i=0; i<stars; i++)

      {

        /* einen Stern mehr rein */

        if (!s[i].in)

          {

            switch (random(3))

              {

                case 0 : s[i].in='.'; break;

                case 1 : s[i].in='+'; break;

                case 2 : s[i].in='*'; break;

              }

            s[i].x=0;

            s[i].y=0;

            s[i].sx=random(51)-25;

            s[i].sy=random(51)-25;

            break;

          }

      }



   for (i=0; i<stars; i++)

     {

       if (s[i].in)

         {

           putstar(s[i].x,s[i].y,' ');

           s[i].x=s[i].x+s[i].sx;

           s[i].y=s[i].y+s[i].sy;

           s[i].sx=s[i].sx+(s[i].sx/10);

           s[i].sy=s[i].sy+(s[i].sy/10);

           if (putstar(s[i].x,s[i].y,s[i].in)) s[i].in=0;

         }

     }



   mydelay(DELAY);



  }

while (saving);

}

