/* definitions for standard programs */



#include <stdlib.h>

#include <conio.h>

#include <stdio.h>

#include <errno.h>

#include <string.h>

#include <ctype.h>

#include <process.h>

#include <nwbindry.h>

#include <nwconn.h>

#include <time.h>



#define TEN_SECONDS 10000

#define OT_ACCESS_SERVER 0x0098

#define DEFAULT_WAIT 60

#define LOGFILE "SYS:\\SYSTEM\\WATCHAS.LOG"

#define LOW 0

#define HIGH 0xff



int portData=0,useLPT=1,portCntr=0;



void logReset(time_t *t)

{

FILE *f;



if (f=fopen(LOGFILE,"a+"))

  {

  fprintf(f,"Reset at %s",ctime(t));

  fclose(f);

  }

}



void portout(int portval)

{

if (portData==0)

  return;

if (useLPT)

  outp(portData,portval);

outp(portCntr,inp(portCntr) & 0xfe);  /* STROBE/DTR = 0 */

delay(1000);

outp(portCntr,inp(portCntr) | 1);     /* STROBE/DTR = 1 */

}



void usage(char *prog,char *msg)

  {

  printf("%s\n",msg);

  printf("Usage load %s -{p|s}<portaddress> -r<resetvalue> -w<waittime> -R\n",prog);

  printf("  portaddress : Address of LPT1 or ? for automatic detection\n");

  printf("   option -p selects printerport, -s serialport\n");

  printf("  resetvalue : value for reset, default %02X\n",LOW);

  printf("  waittime :  Time in seconds to wait for access server to come up\n");

  printf("  -R resets at startup.\n");

  printf("     defaults to %d s\n",DEFAULT_WAIT);

  }



/* return 1 if object of type OT_ACCESS_SERVER is found */



int isalive(void)

{

long OID=-1;

char oName[48];

WORD oType;

return !ScanBinderyObject("*",OT_ACCESS_SERVER,&OID,oName,&oType,NULL,NULL,NULL);

}



void cleanup(void)

{

if (useLPT)

  portout(HIGH);

else

  outp(portCntr,inp(portCntr) | 1);  /* DTR = 1 */

}



int forceReset(void)

{

if (kbhit())

  if (getch()=='R')

    {

    cprintf("\n\rAre you sure? ");

    if (getch()=='Y')

      return 1;

    }

return 0;

}



void main(int argc, char *argv[])

{

time_t t;

int waittime=0;

int resetvalue=LOW;

int i,first=0;



if (argc==1)

  {

  usage(argv[0],"Missing parameters");

  return;

  }



for (i=1;i<argc;i++)

  if (argv[i][0]=='-')

    switch(argv[i][1]) {

      case 'p' :

      case 's' : useLPT=argv[i][1]=='p';

                 portData=(argv[i][2]=='?') ? *(WORD *)(useLPT ? 0x408l : 0x400l) :

                  (int) strtoul(&argv[i][2],NULL,16);

                 break;

      case 'r' : resetvalue=strtoul(&argv[i][2],NULL,16); break;

      case 'w' : waittime=strtoul(&argv[i][2],NULL,10); break;

      case 'R' : first=1; break;

      }

if (waittime==0)

  waittime=DEFAULT_WAIT;

clrscr();

portCntr=portData+(useLPT ? 2 : 4);

AtUnload(cleanup);

printf("%s, port data/control address: %04X/%04X\n",MYNAME,portData,portCntr);

for (;;) {

  if ((!isalive()) || first || forceReset())

    {

    portout(resetvalue);

    delay(1000);

    if (useLPT)

      portout(~resetvalue);

    t=time(NULL);

    printf("\rReset at %s",ctime(&t));

    logReset(&t);

    delay(waittime*1000);

    }

  else

    printf("\r%-60s","Access server(s) alive!");

  delay(TEN_SECONDS);

  first=0;

  }

}

